<?php
/**
* Class demoModule
*
* demo module class
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>            
* @module		demoModule
* @modulegroup	modules
* @access		public
* @version		1.0.0
*/
require_once ASCMS_FRAMEWORK_PATH.'/System.class.php';
require_once ASCMS_FRAMEWORK_PATH.'/File.class.php';

class FileBrowser
{
	/**
	* Template object
	*
	* @access private
	* @var object
	*/
	var $_objTpl;
	
	/**
	* Page title
	*
	* @access private
	* @var string
	*/
	var $_pageTitle;
	
	/**
	* Status message
	*
	* @access private
	* @var string
	*/
	var $_statusMessage = '';
	
	var $_arrFiles = array();
	var $_arrDirectories = array();
	var $_path = "";
	var $_iconWebPath = '';
	/**
	* Constructor
	*/
	function FileBrowser()
	{
		$this->__construct();
	}
	
	/**
	* PHP5 constructor
	*
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/
	function __construct()
	{
		global $_ARRAYLANG;
		
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_CORE_MODULE_PATH.'/fileBrowser/template');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
		
		$this->_iconPath = ASCMS_MODULE_IMAGE_WEB_PATH.'/fileBrowser/';
		$this->_path = $this->_getPath();
		
		$this->_uploadFile();
		$this->_initFiles();
	}
	
	function _getPath()
	{
		$path = "";
		if (isset($_REQUEST['path']) && !stristr($_REQUEST['path'], '..')) {
			$path = $_REQUEST['path'];
		}
		$pos = strrpos($path, '/');
		if ($pos === false || $pos != (strlen($path)-1)) {
			$path .= "/";
		}
		
		return $path;
	}
	
	/**
	* Set the backend page
	*
	* @access public
	* @global object $objTemplate
	* @global array $_ARRAYLANG
	*/
	function getPage() 
	{
		global $_ARRAYLANG;
		
		$this->_objTpl->loadTemplateFile('module_fileBrowser_frame.html');
		
		$this->_objTpl->setVariable(array(
			'FILEBROWSER_WEB_PATH'	=> ASCMS_CONTENT_IMAGE_WEB_PATH.$this->_path,
			'TXT_CLOSE'				=> $_ARRAYLANG['TXT_CLOSE']
		));
		
		$this->_setNaviagtion();
		$this->_setContent();
		$this->_setUploadForm();
		
		$this->_objTpl->show();
	}
	
	function _uploadFile()
	{
		if (isset($_FILES['fileBrowserUploadFile']) && !empty($_FILES['fileBrowserUploadFile'])) {
			$uploadFileName = $_FILES['fileBrowserUploadFile']['name'];
			$file = $uploadFileName;
			$fileExtension = '';
			
			$nr = 1;
			
			if (@file_exists(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$uploadFileName)) {
				if (preg_match('/.*\.(.*)$/', $uploadFileName, $arrSubPatterns)) {
					$fileName = substr($uploadFileName, 0, strrpos($uploadFileName, '.'));
					$fileExtension = $arrSubPatterns[1];
					$file = $fileName.'-'.$nr.'.'.$fileExtension;
					
					while (@file_exists(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file)) {
						$file = substr($uploadFileName, 0, strrpos($uploadFileName, '.')).'-'.$nr.'.'.$fileExtension;
						$nr++;
					}
				} else {
					return false;
				}
			}
			
			move_uploaded_file($_FILES['fileBrowserUploadFile']['tmp_name'], ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file);
			
			$objFile = &new File();
		
			$objFile->setChmod(ASCMS_CONTENT_IMAGE_PATH.$this->_path, ASCMS_CONTENT_IMAGE_WEB_PATH.$this->_path, $file);
		}
	}
	
	function _setNaviagtion()
	{
		$this->_objTpl->addBlockfile('FILEBROWSER_NAVIGATION', 'fileBrowser_navigation', 'module_fileBrowser_navigation.html');
		if (count($this->_arrDirectories) > 0) {
			foreach ($this->_arrDirectories as $arrDirectory) {
				$this->_objTpl->setVariable(array(
					'FILEBROWSER_FILE_PATH'	=> "index.php?cmd=fileBrowser&amp;standalone=true&amp;path=".$arrDirectory['path'],
					'FILEBROWSER_FILE_NAME'	=> $arrDirectory['name'],
					'FILEBROWSER_FILE_ICON'	=> $arrDirectory['icon']
				));
				$this->_objTpl->parse('navigation_directories');
			}
		}
		
		$this->_objTpl->parse('fileBrowser_navigation');
	}
	
	function _setContent()
	{
		$this->_objTpl->addBlockfile('FILEBROWSER_CONTENT', 'fileBrowser_content', 'module_fileBrowser_content.html');
		
		$rowNr = 0;
		
		if (count($this->_arrDirectories) > 0) {
			foreach ($this->_arrDirectories as $arrDirectory) {
				$this->_objTpl->setVariable(array(
					'FILEBROWSER_ROW_CLASS'			=> $rowNr%2 == 0 ? "row1" : "row2",
					'FILEBROWSER_FILE_PATH'			=> "index.php?cmd=fileBrowser&amp;standalone=true&amp;path=".$arrDirectory['path'],
					'FILEBROWSER_FILE_NAME'			=> $arrDirectory['name'],
					'FILEBROWSER_FILESIZE'			=> '&nbsp;',
					'FILEBROWSER_FILE_ICON'			=> $arrDirectory['icon'],
					'FILEBROWSER_FILE_DIMENSION'	=> '&nbsp;'
				));
				$this->_objTpl->parse('content_files');
				
				$rowNr++;
			}
		}
		if (count($this->_arrFiles) > 0) {
			foreach ($this->_arrFiles as $arrFile) {
				$this->_objTpl->setVariable(array(
					'FILEBROWSER_ROW_CLASS'			=> $rowNr%2 == 0 ? "row1" : "row2",
					'FILEBROWSER_FILE_PATH'			=> "javascript:setUrl('".urlencode($arrFile['path'])."')",
					'FILEBROWSER_FILE_NAME'			=> $arrFile['name'],
					'FILEBROWSER_FILESIZE'			=> $arrFile['size'].' KB',
					'FILEBROWSER_FILE_ICON'			=> $arrFile['icon'],
					'FILEBROWSER_FILE_DIMENSION'	=> $arrFile['dimension']
				));
				$this->_objTpl->parse('content_files');
				
				$rowNr++;
			}
		}
		
		$this->_objTpl->setVariable('FILEBROWSER_IMAGE_PATH', ASCMS_CONTENT_IMAGE_WEB_PATH);
		
		$this->_objTpl->parse('fileBrowser_content');
	}
	
	function _setUploadForm()
	{
		$objFWSystem = &new FWSystem();
		
		$this->_objTpl->addBlockfile('FILEBROWSER_UPLOAD', 'fileBrowser_upload', 'module_fileBrowser_upload.html');
		$this->_objTpl->setVariable(array(
			'FILEBROWSER_WEB_PATH'		=> $this->_path,
			'FILEBROWSER_MAX_FILE_SIZE'	=> $objFWSystem->getMaxUploadFileSize(),
			'TXT_UPLOAD_FILE'			=> 'Datei hinaufladen'
		));
		
		$this->_objTpl->parse('fileBrowser_upload');
	}
	
	function _initFiles()
	{
		$objDir = @opendir(ASCMS_CONTENT_IMAGE_PATH.$this->_path);
		
		if ($objDir) {
			if ($this->_path !== "/" && preg_match('#(.*/).+[/]?$#',$this->_path, $path)) {
				array_push($this->_arrDirectories, array('name' => '..', 'path' => $path[1], 'icon' => $this->_iconPath.'_folder.gif'));
			}
			
			while ($file = readdir($objDir)) {
				if ($file == '.' || $file == '..') {
					continue;
				}
				
				if (is_dir(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file)) {
					array_push($this->_arrDirectories, array('name' => $file, 'path' => $this->_path.$file, 'icon' => $this->_getIcon(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file)));
				} else {
					$filesize = filesize(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file);
					if ($filesize > 0) {
						$filesize = round($filesize/1024);
					} else {
						$filesize = 0;
					}
					$arrDimensions = getimagesize(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file);
					array_push($this->_arrFiles, array('name' => $file, 'path' => $this->_path.$file, 'size' => $filesize, 'icon' => $this->_getIcon(ASCMS_CONTENT_IMAGE_PATH.$this->_path.$file), 'dimension' => $arrDimensions[0].'x'.$arrDimensions[1]));
				}
			}
			closedir($objDir);
		}
	}
	
	// gets the icon for the file
    function _getIcon($file)
    {
        if (is_file($file)) {
            $info = pathinfo($file);
		    $icon = $info['extension'];
        }
        
        if (is_dir($file)) {
            $icon = '_folder';
        }
        
        if (!file_exists(ASCMS_MODULE_IMAGE_PATH.'/fileBrowser/'.$icon.'.gif') or !isset($icon)){
			$icon = '_blank';
		}
		return $this->_iconPath.$icon.'.gif';
    }
}
?>
