<?php
/**
* CMS Main page
*
* The main page for the CMS
*
* @copyright     CONTREXX CMS - Astalavista IT Engineering GmbH Thun 
* @author        ASTALAVISTA Development Team   
* @module        index
* @module        index
* @modulegroup   core   
* @version       $Id:     Exp $     
*/

//-------------------------------------------------------
// Set error reporting
//-------------------------------------------------------
error_reporting (E_ALL ^ E_NOTICE);
$starttime = gettimeofday();

require_once dirname(__FILE__).'/config/configuration.php';

//-------------------------------------------------------
// Check if system is installed
//-------------------------------------------------------
if (CONTEXX_INSTALLED === false) {
	header("Location: installer/index.php");
}


require_once dirname(__FILE__).'/core/API.php';

//-------------------------------------------------------
// Initialize database object
//-------------------------------------------------------
$errorMsg = '';
$objDatabase = getDatabaseObject($errorMsg);
if ($objDatabase === false) {
	die('Database error.');
}

// $objDatabase->debug=true;

//-------------------------------------------------------
// Load settings and configuration
//-------------------------------------------------------

$objInit = &new InitCMS();
$_CONFIG = $objInit->loadConfiguration();
$_LANGID = $objInit->getFrontendLangId();

$_CORELANG = $objInit->loadLanguageData('core');
$_ARRAYLANG = $objInit->loadLanguageData();

//-------------------------------------------------------
// Webapp Intrusion Detection System
//-------------------------------------------------------

if ($_CONFIG['coreIdsStatus']=='on') {
	$objSecurity = &new Security;
	$_GET = $objSecurity->detectIntrusion($_GET);	
	$_POST = $objSecurity->detectIntrusion($_POST);
	$_COOKIE = $objSecurity->detectIntrusion($_COOKIE); 
	$_REQUEST = $objSecurity->detectIntrusion($_REQUEST);   
}

//-------------------------------------------------------
// initialize objects
//-------------------------------------------------------

// OLD database link object will get removed a.s.a.p!
$db = &new astalavistaDB;

// OLD new database link object
$objDb =&new astalavistaDB;

// $objTemplate = &new HTML_Template_Sigma(ASCMS_ADMIN_TEMPLATE_PATH);
$objTemplate = &new HTML_Template_Sigma(ASCMS_THEMES_PATH);


$objTemplate->setErrorHandling(PEAR_ERROR_DIE);

$section = isset($_REQUEST['section']) ? (get_magic_quotes_gpc() ? $_REQUEST['section'] : addslashes($_REQUEST['section'])) : "";
$command = isset($_REQUEST['cmd']) ? (get_magic_quotes_gpc() ? $_REQUEST['cmd'] : addslashes($_REQUEST['cmd'])) : "";
$page = isset($_REQUEST['page']) ? intval($_GET['page']) : "";

$pageId	= $objInit->getPageID($page, $section, $command);
$is_home = $objInit->is_home;

$objNavbar  = &new Navigation($pageId);
$objCounter = &new statsLibrary();
$objCounter->checkForSpider();
$themesPages = $objInit->getTemplates();

$query="SELECT content, 
               title,
               redirect, 
               metadesc, 
               metakeys, 
               metarobots, 
               css_name,
               protected,
               frontend_access_id
          FROM ".DBPREFIX."content,
               ".DBPREFIX."content_navigation
         WHERE id = '$pageId' AND id= catid
           AND (startdate<=CURDATE() OR startdate='0000-00-00')
           AND (enddate>=CURDATE() OR enddate='0000-00-00')";
$objResult = $objDatabase->SelectLimit($query, 1);
if ($objResult === false || $objResult->EOF) {
	header("Location: ?section=error&id=404");
	exit;
} else {
	$page_content = stripslashes($objResult->fields["content"]);
	$page_title  = strip_tags(stripslashes($objResult->fields["title"]));
	$page_keywords  = strip_tags(stripslashes($objResult->fields["metakeys"]));
	$page_robots  = strip_tags(stripslashes($objResult->fields["metarobots"]));
	$pageCssName  = strip_tags(stripslashes($objResult->fields["css_name"]));
	$page_desc  = strip_tags(stripslashes($objResult->fields["metadesc"]));
	$page_redirect 	= strip_tags(stripslashes($objResult->fields["redirect"]));
	$page_protected = $objResult->fields["protected"];
	$page_access_id   = $objResult->fields["frontend_access_id"];
	$page_template = $themesPages['content'];
}

if (!empty($page_redirect)){
	header("Location: " . $page_redirect);
	exit;
}

//-------------------------------------------------------
// authentification for protected pages
//-------------------------------------------------------
if ($page_protected){		
	$sessionObj=&new cmsSession();	
	$sessionObj->cmsSessionStatusUpdate($status="frontend");

	$objAuth = &new Auth($type='frontend');		
	if ($objAuth->checkAuth()) {
		$objPerm =&new Permission($type='frontend');
		if (!$objPerm->checkAccess($page_access_id, 'dynamic')) {
			header ("Location: ?section=login&cmd=noaccess");
			exit;
		}
	} else {
		$link=base64_encode($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']);
		header ("Location: ?section=login&redirect=".$link);
		exit;
	}
	$loginStatus = $objAuth->status();
}

//-------------------------------------------------------
// Start page or default page for no section
//-------------------------------------------------------
if ($is_home){		
	$page_template  = $themesPages['home'];	
}

//-------------------------------------------------------
// Set news teasers
//-------------------------------------------------------
if ($_CONFIG['newsTeasersStatus'] == '1') {
	// set news teasers in the content
	if (preg_match_all('/{TEASERS_([0-9A-Z_-]+)}/ms', $page_content, $arrMatches)) {
		$modulespath = "core_modules/news/teasers.class.php";
		if (file_exists($modulespath)) {
			include_once($modulespath);
			$objTeasers = &new Teasers();
			$objTeasers->setTeaserFrames($arrMatches[1], $page_content);
		}
	}
	
	// set news teasers in the page design
	if (preg_match_all('/{TEASERS_([0-9A-Z_-]+)}/ms', $page_template, $arrMatches)) {
		$modulespath = "core_modules/news/teasers.class.php";
		if (file_exists($modulespath)) {
			include_once($modulespath);
			$objTeasers = &new Teasers();
			$objTeasers->setTeaserFrames($arrMatches[1], $page_template);
		}
	}
	
	// set news teasers in the website design
	if (preg_match_all('/{TEASERS_([0-9A-Z_-]+)}/ms', $themesPages['index'], $arrMatches)) {
		$modulespath = "core_modules/news/teasers.class.php";
		if (file_exists($modulespath)) {
			include_once($modulespath);
			$objTeasers = &new Teasers();
			$objTeasers->setTeaserFrames($arrMatches[1], $themesPages['index']);
		}
	}
}

//-------------------------------------------------------
// Get Headlines
//-------------------------------------------------------
$modulespath = "core_modules/news/headlines.class.php";
if (file_exists($modulespath)) include_once($modulespath);
$newsHeadlinesObj = &new newsHeadlines($themesPages['headlines']);
$page_content = str_replace('{HEADLINES_FILE}', $newsHeadlinesObj->getHomeHeadlines(), $page_content);
$themesPages['index'] = str_replace('{HEADLINES_FILE}', $newsHeadlinesObj->getHomeHeadlines(), $themesPages['index']);
$page_template = str_replace('{HEADLINES_FILE}', $newsHeadlinesObj->getHomeHeadlines(), $page_template);

//-------------------------------------------------------
// Load design template
//-------------------------------------------------------
$objTemplate->setTemplate($themesPages['index']);
$objTemplate->addBlock('CONTENT_FILE', 'page_template', $page_template);

//-------------------------------------------------------
// start module switches
//-------------------------------------------------------
switch ($section){
//-------------------------------------------------------
// Login module
//-------------------------------------------------------
	case "login":
		$modulespath = "core_modules/login/index.class.php";
		if (file_exists($modulespath)) require_once($modulespath);
		else die($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
		if (!isset($sessionObj) || !is_object($sessionObj)) $sessionObj=&new cmsSession(); 
		if (!isset($objAuth) || !is_object($objAuth)) $objAuth = &new Auth($type='frontend');
		if (!isset($objPerm) || !is_object($objPerm)) $objPerm =&new Permission($type='frontend');
		$objLogin = &new Login($page_content);
		$objTemplate->setVariable('CONTENT_TEXT', $objLogin->getContent());
	break;

//-------------------------------------------------------
// eCommerce Module
//-------------------------------------------------------
    case "shop":             
		$modulespath = "modules/shop/index.class.php";
		if (file_exists($modulespath)) require_once($modulespath);
		else die($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
		if (!isset($sessionObj) || !is_object($sessionObj)) $sessionObj=&new cmsSession(); 
		$shopObj = &new Shop($page_content);		
		$objTemplate->setVariable('CONTENT_TEXT', $shopObj->getShopPage());
		$objTemplate->setVariable('SHOPNAVBAR_FILE', $shopObj->getShopNavbar($themesPages['shopnavbar']));             		     		
	break;
	
//-------------------------------------------------------
// Community module
//-------------------------------------------------------
    case "community":
        $modulespath = "modules/community/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        if (!isset($sessionObj) || !is_object($sessionObj)) $sessionObj=&new cmsSession(); 
        if (!isset($objAuth) || !is_object($objAuth)) $objAuth = &new Auth($type = 'frontend');
		$communityObj = &new Community($page_content);
		$objTemplate->setVariable('CONTENT_TEXT', $communityObj->getCommunityPage());
	break;

//-------------------------------------------------------
// News module
//-------------------------------------------------------
    case "news":
        $modulespath = "core_modules/news/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        if (isset($_GET['cmd']) && $_GET['cmd'] == "submit") {
			if (!isset($sessionObj) || !is_object($sessionObj)) $sessionObj=&new cmsSession();
			$sessionObj->cmsSessionStatusUpdate($status="frontend");
			if (!isset($objAuth) || !is_object($objAuth)) $objAuth = &new Auth($type = 'frontend');
			if (!isset($objPerm) || !is_object($objPerm)) $objPerm = &new Permission();
			require_once ASCMS_CORE_PATH.'/wysiwyg.class.php';
        }
        
		$newsObj= &new news($page_content);
		$objTemplate->setVariable('CONTENT_TEXT', $newsObj->getNewsPage());
		$newsObj->getPageTitle($page_title);
		$page_title = $newsObj->newsTitle;
	break;
	
//-------------------------------------------------------
// Guestbook
//-------------------------------------------------------
	case "guestbook":
		$modulespath = "modules/guestbook/index.class.php";
		if (file_exists($modulespath)) require_once($modulespath);
		else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
		$objGuestbook = &new Guestbook($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $objGuestbook->getPage());
	break;

//-------------------------------------------------------
// Download
//-------------------------------------------------------
	case "download":
		$modulespath = "modules/download/index.class.php";
		if (file_exists($modulespath)) require_once($modulespath);
		else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
		$objDownload = &new Download($page_content);
		$objTemplate->setVariable('CONTENT_TEXT', $objDownload->getPage());
	break;
	    
//-------------------------------------------------------
// DocumentSystem module
//-------------------------------------------------------
    case "docsys":
        $modulespath = "modules/docsys/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $docSysObj= &new docSys($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $docSysObj->getDocSysPage());
        $docSysObj->getPageTitle($page_title);
        $page_title = $docSysObj->docSysTitle;
	break;
          
//-------------------------------------------------------
// Search Module
//-------------------------------------------------------
    case "search":
        $modulespath = "core_modules/search/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $pos = (isset($_GET['pos'])) ? intval($_GET['pos']) : "";
        $objTemplate->setVariable('CONTENT_TEXT', search_getSearchPage($pos, $page_content));
        unset($pos);
	break;

//-------------------------------------------------------
// Contact Module
//-------------------------------------------------------
    case "contact":
        $modulespath = "core_modules/contact/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $contactObj= &new Contact($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $contactObj->getContactPage());
	break;

//-------------------------------------------------------
// Sitemap Core
//-------------------------------------------------------
    case "ids":	
    	$objTemplate->setVariable('CONTENT_TEXT', $page_content);
        break;
        
//-------------------------------------------------------
// Sitemapping
//-------------------------------------------------------
	case "sitemap":  
        $modulespath = "core_modules/sitemap/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $sitemap = &new sitemap($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $sitemap->getSitemapContent());
	break;
                      
//-------------------------------------------------------
// media Core
//-------------------------------------------------------
	case "media1":
	case "media2":
	case "media3":
	    if(!isset($sessionObj)|| !is_object($sessionObj)) $sessionObj = &new cmsSession(); 
		$modulespath = ASCMS_CORE_MODULE_PATH . '/media/index.class.php';
		if (file_exists($modulespath)) require_once($modulespath);
		else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']); 
		$objMedia = &new MediaManager($page_content, $section);
		$objTemplate->setVariable('CONTENT_TEXT', $objMedia->getMediaPage());
	break;
        
//-------------------------------------------------------
// newsletter Module
//-------------------------------------------------------
	case "newsletter":    
        $modulespath = "modules/newsletter/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $newsletter = &new newsletter($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $newsletter->getPage());
	break;
        
//-------------------------------------------------------
// gallery Module
//-------------------------------------------------------
	case "gallery":
		$modulespath = "modules/gallery/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
		else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $objGallery = &new Gallery($page_content);
        $objTemplate->setVariable("CONTENT_TEXT", $objGallery->getPage());
	break;

//-------------------------------------------------------
// Voting
//-------------------------------------------------------
	case "voting":	
		$modulespath = "modules/voting/index.class.php";
		if (file_exists($modulespath)) require_once($modulespath);
		else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
		$objTemplate->setVariable("CONTENT_TEXT", votingShowCurrent($page_content));
	break;

//-------------------------------------------------------
// News Feed Module
//-------------------------------------------------------
	case "feed":
        $modulespath = "modules/feed/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $objFeed = &new feed($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $objFeed->getFeedPage());
	break;
	    
//-------------------------------------------------------
// Calendar Module
//-------------------------------------------------------
	case "calendar":
        $modulespath = "modules/calendar/index.class.php";
        if (file_exists($modulespath)) require_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $objCalendar = &new Calendar($page_content);
        $objTemplate->setVariable("CONTENT_TEXT", $objCalendar->getCalendarPage());
	break;
	
//-------------------------------------------------------
// Directory Module
//-------------------------------------------------------
  case "directory":                
        $modulespath = "modules/directory/index.class.php";
        if (file_exists($modulespath)) include_once($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']); 
        $directory = &new rssDirectory($page_content);	       
        $objTemplate->setVariable("CONTENT_TEXT", $directory->getPage());
        break;   
	    
//-------------------------------------------------------
// Forum Module
//-------------------------------------------------------
	case "forum":
		$modulespath = "modules/forum/index.class.php";
		if (file_exists($modulespath)) require_once($modulespath);
		else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
		if (!isset($sessionObj) || !is_object($sessionObj)) $sessionObj = &new cmsSession();
		if (!isset($objPerm) || !is_object($objPerm)) $objPerm = &new Permission($type='frontend');
		$objForum = &new Forum($page_content);
		$objTemplate->setVariable('CONTENT_TEXT', $objForum->getPage());
	break;
	
//  		$sessionObj=&new cmsSession();               
//        $modulespath = "modules/forum/index.class.php";
//        if (file_exists($modulespath))require_once($modulespath);
//        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']); 
//        $forum = &new forum($page_content);	   
//        if ($_REQUEST['forumLogin']) {			
//			if ($_SESSION['forum']['userstatus']!=1) {
//				if (!$forum->checklogin()){                                                 
//					$link=base64_encode($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']);		
//					header ("Location: ?section=login&redirect=".$link);	
//				} else {																					
//					$_SESSION['forum']['userstatus']=1;
//				}
//			}	
//		}
//		$objTemplate->setVariable('CONTENT_TEXT', $forum->getPage());
//	break;
        	    
//-------------------------------------------------------
// logout
//-------------------------------------------------------
	case "logout":
		$sessionObj=&new cmsSession();	
	    $objAuth =&new Auth($type='public');
	    $objAuth->logout();
	break;
	    
//-------------------------------------------------------
// error module
//-------------------------------------------------------
    case "error":
        $modulespath = "core/error.class.php";
        if (file_exists($modulespath)) require($modulespath);
        else die ($_CORELANG['TXT_THIS_MODULE_DOESNT_EXISTS']);
        $errorObj= &new error($page_content);
        $objTemplate->setVariable('CONTENT_TEXT', $errorObj->getErrorPage());
	break;

//-------------------------------------------------------
// default case
//-------------------------------------------------------       
    default:
        $objTemplate->setVariable('CONTENT_TEXT', $page_content);
}

//-------------------------------------------------------
// show shop navbar on each page
//-------------------------------------------------------
if(isset($_CONFIGURATION['custom']['shopnavbar']) AND $_CONFIGURATION['custom']['shopnavbar']== TRUE) {
	if (!is_object($shopObj)){
		$modulespath = "modules/shop/index.class.php";
		if (file_exists($modulespath)){
			require_once($modulespath);
			if (!is_object($sessionObj)) $sessionObj=&new cmsSession(); 
			$_ARRAYSHOPLANG = $objInit->loadLanguageData('shop');
			$_ARRAYLANG = array_merge($_ARRAYLANG, $_ARRAYSHOPLANG);
			$shopObj = &new Shop();		
			$objTemplate->setVariable('SHOPNAVBAR_FILE', $shopObj->getShopNavbar($themesPages['shopnavbar']));
		}
	}
}

//-------------------------------------------------------
// Calendar
//-------------------------------------------------------
// print_r($objTemplate->getPlaceholderList());	
/*
$calendarCheck1 = $objTemplate->placeholderExists('CALENDAR');
$calendarCheck2 = $objTemplate->placeholderExists('CALENDAR_EVENTS');
if(!empty($calendarCheck1) OR !empty($calendarCheck2)) {
	$modulespath = "modules/calendar/HomeCalendar.class.php";
	if (file_exists($modulespath)){
		require_once($modulespath);
		$objHomeCalendar = &new HomeCalendar();	
		if(!empty($calendarCheck1)) {
		    $objTemplate->setVariable('CALENDAR', $objHomeCalendar->getHomeCalendar());
		}		
		if(!empty($calendarCheck2)) {
		    $objTemplate->setVariable('CALENDAR_EVENTS', $objHomeCalendar->getHomeCalendarEvents());
		}		
	}
}
*/


//-------------------------------------------------------
// Directory Show Latest
//-------------------------------------------------------
// print_r($objTemplate->getPlaceholderList());	

$directoryCheck = $objTemplate->blockExists('directoryLatest');

if(!empty($directoryCheck)) {
	$modulespath = "modules/directory/HomeDirectory.class.php";
	if (file_exists($modulespath)){
		require_once($modulespath);
		$objHomeDirectory = &new HomeDirectory();	
		if(!empty($directoryCheck)) {
			$objTemplate->setVariable('TXT_DIRECTORY_LATEST', $_CORELANG['TXT_DIRECTORY_LATEST']);
		   	$objHomeDirectory->getHomeLatest();
		}			
	}
}	



//-------------------------------------------------------
// set global template variables
//-------------------------------------------------------
if(!isset($loginStatus))$loginStatus='';

$objTemplate->setVariable(array(
    'CHARSET'				=> $objInit->getFrontendLangCharset(),
    'TITLE'         		=> $page_title,
    'METAKEYS'	        	=> $page_keywords,
    'METADESC'	        	=> $page_desc,
    'METAROBOTS'            => $page_robots,
    'CONTENT_TITLE'		   	=> $page_title,
    'CSS_NAME'              => $pageCssName,
    'PRINT_URL'             => $objInit->getPrintUri(),
    'PAGE_URL'              => $objInit->getPageUri(),
    'DATE'					=> showFormattedDate(),
    'NAVTREE'				=> $objNavbar->getTrail(),
    'SUBNAVBAR_FILE'  		=> $objNavbar->getNavigation($themesPages['subnavbar']), 
    'NAVBAR_FILE'  			=> $objNavbar->getNavigation($themesPages['navbar']), 
    'ONLINE_USERS'			=> $objCounter->getOnlineUsers(),
    'COUNTER'				=> $objCounter->getCounterTag(),
    'VERSION'			   	=> $_CONFIG['coreCmsName'],
    'LANGUAGE_NAVBAR'		=> $objNavbar->getFrontendLangNavigation(),
    'ACTIVE_LANGUAGE_NAME'  => $objInit->getFrontendLangName(),
    'LOGGING_STATUS'        => $loginStatus,
    'RANDOM'                => md5(microtime()),
    'TXT_SEARCH'			=> $_CORELANG['TXT_SEARCH']
));


//-------------------------------------------------------
// parse system
//-------------------------------------------------------
$parsingtime = gettimeofday();
$time = round(($parsingtime['sec'] + $parsingtime['usec'] / 1000000) - ($starttime['sec'] + $starttime['usec'] / 1000000), 5);
$objTemplate->setVariable('PARSING_TIME', $time);

$objTemplate->setVariable(array(
	'SIDEBAR_FILE'     => $themesPages['sidebar'],
	'JAVASCRIPT_FILE'  => $themesPages['javascript'],
	'STYLE_FILE'       => $themesPages['style'],
	'BUILDIN_STYLE_FILE'  => $themesPages['buildin_style']
));

$objTemplate->show();
?>
