<?php
/**
* Modul Calendar
*
* LibClass to manage cms calendar
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>   
* @module Calendar
* @modulegroup   modules
* @access public
* @version 1.0.0  
**/


class calendarLibrary
{
    var $_objTpl;
    var $statusMessage;
    var $calDay;
    var $calMonth;
    var $calYear;
    var $calDate;
    var $calDate2;
    var $calDate3;
    var $calendarDay;
    
	var $calStartYear;
	var $calEndYear;
	var $paging;
	
	var $calendarMonth;
	
	
	
	function calendarLibrary()
	{
	    global $_CONFIG;
	    
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/calendar/template');
        $this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
	    
	    $this->calStartYear = 2004;
	    $this->calEndYear   = 2037;
	    $this->paging       = intval($_CONFIG['corePagingLimit']);
	    
		// get date by $_GET
		if(!isset($_GET['day']) && !isset($_GET['month']) && !isset($_GET['year'])){
			$this->calendarDay = strftime("%d")." ".$this->monthName(strftime("%m"))." ".strftime("%Y");
			$this->calDay      = strftime("%d");
			$this->calMonth    = strftime("%m");
			$this->calYear     = strftime("%Y");
		}
			
		if(!isset($_GET['day']) && isset($_GET['month']) && isset($_GET['year'])){
			$this->calendarDay = $this->monthName(strip_tags($_GET['month']))." ".intval($_GET['year']);
			$this->calDay      = 0;
			$this->calMonth    = $_GET['month'];
			$this->calYear     = $_GET['year'];
		}
			
		if(isset($_GET['day']) && isset($_GET['month']) && isset($_GET['year'])){
			$this->calendarDay = strip_tags($_GET['day'])." ".$this->monthName(intval($_GET['month']))." ".intval($_GET['year']);
			$this->calDay      = $_GET['day'];
			$this->calMonth    = $_GET['month'];
			$this->calYear     = strip_tags($_GET['year']);
		}
		
		$this->calDate  = $this->calMonth."/".$this->calDay."/".$this->calYear;
		$this->calDate2 = $this->calDay.$this->calMonth.$this->calYear;
		$this->calDate3 = $this->calYear.$this->calMonth.$this->calDay;
	}
    
	
	
	// write month names
	function monthName($month)
	{	
	    global $_ARRAYLANG;
	    
		$months = explode(',', $_ARRAYLANG['TXT_MONTH_ARRAY']);
		$name = $months[$month - 1];
		return $name;	
	}
	
	
	
	// include calendar
	function includeCalendar($link, $catsid='')
	{
	    global $objDatabase, $_ARRAYLANG, $_LANGID, $_CONFIG;
		
	    $events = array();   
	    require_once ASCMS_MODULE_PATH.'/calendar/calendar.class.php';	    
	        
	    if(isset($_GET['month'])){    	
	    	$cal = &new astaCalendar($_GET['month'], $_GET['year']);	    	
		} else{			
			$cal = &new astaCalendar(date('m'), date('Y'));		
		}
		
		// set events for calendar
		$query = "SELECT startdate
		              FROM ".DBPREFIX."module_calendar
		             WHERE id > 0 ".$catsid."
		          ORDER BY id";
		$objResult = $objDatabase->Execute($query);
		
		if ($objResult !== false) {
	        while(!$objResult->EOF) {
	            $events[] = $objResult->fields['date'];
	            $objResult->MoveNext();
	        }
		}
		
		$cal->setEventDays($events);
		$cal->setLinks($link, $link);		
		$this->calendarMonth = $cal->createCalendar();	
	}
	
	
	
	// for go to
	function forGoTo()
	{
		// for goto: months
		for($x = 1; $x <= 12; $x++){
			$x = str_pad($x, 2, '0', STR_PAD_LEFT);
			$name = $this->monthName($x);
			$this->_objTpl->setVariable('CALENDAR_GOTO_MONTH', $x);
			if($x == $this->calMonth){
				$this->_objTpl->setVariable('CALENDAR_GOTO_MONTH_SELECT', ' selected');
			}
			else{
				$this->_objTpl->setVariable('CALENDAR_GOTO_MONTH_SELECT', '');
			}
			$this->_objTpl->setVariable('CALENDAR_GOTO_MONTH_NAME', $name);
			//$this->_objTpl->parse("months");
		}
		
		//for goto: years
		for($x = $this->calStartYear; $x <= $this->calEndYear; $x++){
			$this->_objTpl->setVariable('CALENDAR_GOTO_YEAR', $x);
			if($x == $this->calYear){
				$this->_objTpl->setVariable('CALENDAR_GOTO_YEAR_SELECT', ' selected');
			}else{
				$this->_objTpl->setVariable('CALENDAR_GOTO_YEAR_SELECT', '');
			}
//			$this->_objTpl->parse("years");
		}
	}
	
	
	
	// get day note
	function getDayNote($id)
	{
	    global $objDatabase, $_ARRAYLANG, $_LANGID;
				
		$query = "SELECT id,
		                   catid,
		                   date, 
		                   time, 
		                   end_date, 
		                   end_time, 
		                   priority, 
		                   name, 
		                   comment, 
		                   place,
		                   info
		              FROM ".DBPREFIX."module_calendar
		             WHERE id = '".intval($id)."'";
		
		$objResult = $objDatabase->Execute($query);
		
			$title	   = substr($objResult->fields['date'], 3, 2)." ";
			$title	  .= $this->monthName(substr($objResult->fields['date'], 0, 2))." ";
			$title	  .= substr($objResult->fields['date'], 6, 4);
			$time	   = substr($objResult->fields['time'], 0, 2).":".substr($objResult->fields['time'], 2, 2)." - ";
			$time     .= substr($objResult->fields['date'], 3, 2).".".substr($objResult->fields['date'], 0, 2).".".substr($objResult->fields['date'], 6, 4);
			$end_time  = substr($objResult->fields['end_time'], 0, 2).":".substr($objResult->fields['end_time'], 2, 2)." - ";
			$end_time .= substr($objResult->fields['end_date'], 3, 2).".".substr($objResult->fields['end_date'], 0, 2).".".substr($objResult->fields['end_date'], 6, 4);
			$comment   = str_replace("\n", '<br />', $objResult->fields['comment']);
	
		if($objResult->fields['priority'] == 1){
			$priority_gif = 'priority2h';
		}
		elseif($objResult->fields['priority'] == 2){
			$priority_gif = 'priorityh';
		}
		elseif($objResult->fields['priority'] == 3){
			$priority_gif = 'priorityno';
		}
		elseif($objResult->fields['priority'] == 4){
			$priority_gif = 'priorityl';
		}
		elseif($objResult->fields['priority'] == 5){
			$priority_gif = 'priority2l';
		}
		
		$query = "SELECT name
		               FROM ".DBPREFIX."module_calendar_categories
		              WHERE id = '".$objResult->fields['catid']."'";
		$objResult2 = $objDatabase->SelectLimit($query);
		
		$info = explode(" ", $objResult->fields['info']);
		
		$info_href   = $info[0];
		$info_target = $info[1];
		if($info[0] == 'http://' OR $info[0] == ''){
			$info_href   = 'javascript:{};';
			$info_target = '';
			$calendarInfoLink = "";
		} else {
		    $calendarInfoLink = "<a href='".$info_href."' target='".$info_target."'>".$info_href."</a>";	
		}
	    
	    // parse to template
		$this->_objTpl->setVariable(array(
		    'TXT_CALENDAR_CAT'            => $_ARRAYLANG['TXT_CALENDAR_CAT'],
			'TXT_CALENDAR_DATE'		      => $_ARRAYLANG['TXT_CALENDAR_DATE'],
			'TXT_CALENDAR_NAME'		      => $_ARRAYLANG['TXT_CALENDAR_NAME'],
			'TXT_CALENDAR_PLACE'	      => $_ARRAYLANG['TXT_CALENDAR_PLACE'],
			'TXT_CALENDAR_PRIORITY'	      => $_ARRAYLANG['TXT_CALENDAR_PRIORITY'],
			'TXT_CALENDAR_START'	      => $_ARRAYLANG['TXT_CALENDAR_START'],
			'TXT_CALENDAR_END'		      => $_ARRAYLANG['TXT_CALENDAR_END'],
			'TXT_CALENDAR_COMMENT'	      => $_ARRAYLANG['TXT_CALENDAR_COMMENT'],
			'TXT_CALENDAR_INFO'           => $_ARRAYLANG['TXT_CALENDAR_INFO'],
			'TXT_CALENDAR_BACK'           => $_ARRAYLANG['TXT_CALENDAR_BACK'],
			'CALENDAR_TITLE'		      => $title,
			'CALENDAR_NAME'			      => $objResult->fields['name'],
			'CALENDAR_PLACE'		      => $objResult->fields['place'],
			'CALENDAR_PRIORITY_GIF'       => $priority_gif,
			'CALENDAR_PRIORITY'		      => $objResult->fields['priority'],
			'CALENDAR_START'		      => $time,
			'CALENDAR_END'			      => $end_time,
			'CALENDAR_COMMENT'		      => $comment,
			'CALENDAR_ID'			      => $id,
			'CALENDAR_CAT'                => $objResult2->fields['name'],
			'CALENDAR_INFO'               => $info[0],
			'CALENDAR_INFO_HREF'          => $info_href,
			'CALENDAR_INFO_TARGET'        => $info_target,
			'CALENDAR_INFO_LINK' => $calendarInfoLink
		));
	}
  
  /**
   *  function dateNumber
   *
   *  convert date-number from one-digit to two-digit
   */
  
  function dateNumber($number)
  {
      $number = intval($number);
      if(strlen($number)==1)
      {
          $number = '0'.$number;
      }
      return $number;
  }//end function	
  
  
	/**
     * stamp to date
     *
     * Gets the date out of a
     * timestamp.
     * If type is year, month or day,
     * only the given type is returned
	 */
	function stampToDate($stamp, $type=NULL)
	{
		$year 	= substr($stamp, 0, 4);
		$month 	= substr($stamp, 4, 2);
		$day 	= substr($stamp, 6, 2);
		
		if ($type == "day") {
			$retval = sprintf("%02d", $day);
		} elseif ($type == "month") {
			$retval =  sprintf("%02d", $month);
		} elseif ($type == "year") {
			$retval =  sprintf("%04d", $year);
		} else {
			$retval = sprintf("%04d-%02d-%02d", $year, $month, $day);
		}
		
		return $retval;
	}
	
	/**
	 * stamp to time
	 *
	 * Gets the time out of a timestamp
	 */
	function stampToTime($stamp)
	{
		$hour 		= substr($stamp, 8, 2);
		$minutes 	= substr($stamp, 10, 2);
		
		return "$hour:$minutes";
	}
	
	
	/**
	 * date to stamp
	 *
	 * Makes a timestamp based on the params
	 */
	function dateToStamp($year, $month, $day, $hour, $minutes)
	{
		return sprintf("%04d%02d%02d%02d%02d", $year, $month, $day, $hour, $minutes);
	}
	
}
?>
