<?php
/**
* Modul Calendar
*
* Class to manage cms calendar
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>
* @module Calendar
* @modulegroup modules
* @access public
* @version 1.0.0 
**/


//error_reporting(E_ALL);
require_once ASCMS_MODULE_PATH .'/calendar/lib/activecalendar.php';
require_once ASCMS_MODULE_PATH . '/calendar/calendarLib.class.php';


class Calendar extends calendarLibrary
{ 	
    // {{{ properties

   /**
     * XML parser handle
     *
     * @var  array
     * @see  xml_parser_create()
     */
  

	/**
	* PHP5 Constructor
	*
	*/	
	function Calendar($pageContent) 
	{
	    $this->__construct($pageContent);	
	}
	
	
	/**
	* Constructor
	*
	* Construct the Calendar functions
	*
	* @access	public
	* @param    string $pageContent
	*/		
    function __construct($pageContent)
    {
    	$this->calendarLibrary();
    	$this->categoryInfo(); 	
	    $this->pageContent = $pageContent;
	}   

	
    // GET PAGE
    function getCalendarPage()
    {
    	if(!isset($_REQUEST['cmd'])){
    		$_REQUEST['cmd'] = '';
    	}
    	
    	switch($_REQUEST['cmd']){
    		case 'note':
		    	return $this->showDayNote();
		    	break;
		    default:
		        return $this->showDay();
		        break;
    	}
    }

    
	// default case
	function showDay() 
	{	
	    global $_ARRAYLANG, $_LANGID, $objDatabase;
	    
	    // http://www.contrexx.com/index.php?section=calendar&month=01&year=2006&catid=1  
		$this->_objTpl->setTemplate($this->pageContent);
		
		// get std cat
		if(!isset($_GET['catid']) or empty($_GET['catid'])){
			$query = "SELECT stdCat FROM ".DBPREFIX."module_calendar_style WHERE id = '2'"; 
			$objResult = $objDatabase->SelectLimit($query, 1);
		    
		    $array1 = explode(' ', stripslashes($objResult->fields["stdCat"]));		  
			$cats   = '';
			
			foreach($array1 as $out){
				$array2 = explode('>', $out);
				$cats[$array2[0]] = $array2[1];
			}
			
			$_GET['catid'] = $cats[$_LANGID];
			if($_GET['catid'] == ''){
				$_GET['catid'] = 0;
			}
		}
		
		if($_GET['catid'] != 0){
			$query = "SELECT id
		    	          FROM ".DBPREFIX."module_calendar_categories
		        	     WHERE id = '".intval($_GET['catid'])."'
			               AND lang = '".$_LANGID."'
			               AND status = '1'";
			$objResult = $objDatabase->SelectLimit($query, 1);
			
			if($objDatabase->Affected_Rows() == 0){
				$_GET['catid'] = 0;
			}
		}
		
		// request_uri
		$requestUri = str_replace('&catid='.$_GET['catid'], '', $_SERVER['REQUEST_URI']);
		
		// select category
		$this->_objTpl->setVariable(array(
		    'TXT_CALENDAR_ALL_CAT' => $_ARRAYLANG['TXT_CALENDAR_ALL_CAT']
		));
		
		$query = "SELECT id,
		                   name
		              FROM ".DBPREFIX."module_calendar_categories
		             WHERE lang = '".$_LANGID."'
		               AND status = '1'
		          ORDER BY pos";
		
		$objResult = $objDatabase->Execute($query);
		
		$cats = '';
		if ($objResult !== false) {
			while(!$objResult->EOF) {
				$select = ($objResult->fields['id'] == $_GET['catid']) ? 'selected' : '';
				
				$this->_objTpl->setVariable(array(
				    'CALENDAR_CAT_ID'      => $objResult->fields['id'],
				    'CALENDAR_CAT_SELECT'  => $select,
				    'CALENDAR_CAT_NAME'    => $objResult->fields['name']
				));
				$this->_objTpl->parse("calendar_cat");
				$cats[] = $objResult->fields['id'];
				
				$objResult->MoveNext();
			}
		}
		
		// make cat ids
		if(!isset($_GET['catid']) or $_GET['catid'] == ''){
			$_GET['catid'] = 0;
		}
		
		if(isset($_GET['catid']) and $_GET['catid'] != 0){
		    $catslang = "AND catid = '".intval($_GET['catid'])."'";	
		}else{
			if(is_array($cats)){
				for($x = 0; $x < count($cats); $x++){
					if($x == 0){
						$catslang  = "AND (catid = '".$cats[$x]."' ";
					}else{
						$catslang .= "OR catid = '".$cats[$x]."' ";
					}
					
				}
				$catslang .= ')';
			}
			else{
				$catslang = '';
			}
		}
		
		// include calendar
		$this->includeCalendar("?section=calendar&amp;catid=".intval($_GET['catid']), $catslang);
		
		// for goto
		$this->forGoTo();
		
		// no view
		if(!isset($_GET['day']) && !isset($_GET['month']) && !isset($_GET['year'])) {
		    $i = 0;	    
		    $this->_objTpl->setVariable(array(
		            'START_ROWS' => '<!-- ',
		            'END_ROWS' => ' -->',
			        'START_EVENT' => '',
			        'END_EVENT' => '',
			        'START_ROWS2' => '<!-- ',
			        'END_ROWS2' => ' -->',
			        'START_ROWS3' => '',
			        'END_ROWS3'=> ''
		    ));
		    
		    $query = "SELECT shownEvents FROM ".DBPREFIX."module_calendar_style WHERE id = '2'";
		    $objResult = $objDatabase->Execute($query);		    
		    $paging = $objResult->fields['shownEvents'];
			
		    $query = "SELECT id,
			                   catid,
			                   date,
			                   time,
			                   name
			              FROM ".DBPREFIX."module_calendar
			             WHERE sort >= '".$this->calDate3."'
			                   ".$catslang."
			          ORDER BY sort ASC, 
			                   time ASC, 
			                   priority ASC, 
			                   id ASC
			             LIMIT ".$paging;
			$objResult = $objDatabase->Execute($query);
			
			
			// write table
			if ($objResult !== false) {
				while(!$objResult->EOF) {	
					$class = ($i % 2) ? "calendar2" : "calendar1";							
					$date    = substr($objResult->fields['date'], 3, 2).".".substr($objResult->fields['date'], 0, 2).".".substr($objResult->fields['date'], 6, 4);
					$time    = substr($objResult->fields['time'], 0, 2).":".substr($objResult->fields['time'], 2, 2);
					$link  = "?section=calendar&catid=".intval($_GET['catid'])."&month=".substr($objResult->fields['date'], 0, 2);
					$link .= "&day=".substr($objResult->fields['date'], 3, 2)."&year=".substr($objResult->fields['date'], 6, 4);
					$link2 = "?section=calendar&cmd=note&id=".$objResult->fields['id'];
		
					$this->_objTpl->setVariable(array(
					    'CALENDAR_CLASS'     => $class,
					    'CALENDAR_LINK'      => $link,
					    'CALENDAR_DATE'      => $date,
					    'CALENDAR_TIME'      => $time,
					    'CALENDAR_LINK2'     => $link2,
					    'CALENDAR_NAME'      => $objResult->fields['name'],
					    'CALENDAR_CAT'       => $this->arrCategories[$objResult->fields['catid']]['name']
					));
					
					$this->_objTpl->parse("rows3");
					$i++;
					$objResult->MoveNext();
				}
			}
			
			if($i == 0){
				$this->_objTpl->setVariable('CALENDAR_EVENT', $_ARRAYLANG['TXT_CALENDAR_EVENTS_NO']);
			    $this->_objTpl->setVariable(array(
				        'START_ROWS3'  => '<!-- ',
				        'END_ROWS3'    => ' -->'
			    ));
			} else {
				$this->_objTpl->setVariable('CALENDAR_EVENT', $_ARRAYLANG['TXT_CALENDAR_EVENTS'].": $i");
			}
			
			$this->_objTpl->parse("event");
			$this->_objTpl->setVariable('CALENDAR_DATE', $_ARRAYLANG['TXT_NEXT_CALENDAR_EVENTS']);		    
		}
		
		// day view
		if(isset($_GET['day']) && isset($_GET['month']) && isset($_GET['year'])){		
		    $this->_objTpl->setVariable(array(
		            'START_ROWS'        => '',
		            'END_ROWS'          => '',
			        'START_EVENT'       => '<!-- ',
			        'END_EVENT'         => ' -->',
			        'START_ROWS2'       => '<!-- ',
			        'END_ROWS2'         => ' -->',
			        'START_ROWS3'       => '<!-- ',
			        'END_ROWS3'         => ' -->'
		    ));
				
            // get day events
	        $query = "SELECT id, time, name, comment
	        	             FROM ".DBPREFIX."module_calendar
	                         WHERE date = '$this->calDate' ".$catslang."
	                      ORDER BY time ASC, priority DESC, id DESC";
	        $objResult = $objDatabase->Execute($query);
	        
	        if ($objResult !== false) {
			while(!$objResult->EOF) {
				$y = round($objResult->fields['time'] / 100, 0);
				$dayNote[$y]  = "<a href='?section=calendar&cmd=note&id=".$objResult->fields['id']."' title='".$_ARRAYLANG['TXT_CALENDAR_SHOW'];
				$dayNote[$y] .= ": ".$objResult->fields['name']."' hidefocus>";
				$dayNote[$y] .= "<img src='images/modules/calendar/groups.gif' align='absmiddle' border='0'></a>&nbsp;\n".$objResult->fields['name'];
				$dayNotes[$y] = substr(str_replace("\n", '', $objResult->fields['comment']), 0, 40)."...";
				
				$objResult->MoveNext();		
            }
			
			// make empty day events
			for($y = 0; $y < 24; $y++){
				if(!isset($dayNote[$y])){
					$dayNote[$y]  = "<img src='images/modules/calendar/pixel.gif' height='16' width='16' alt='' />";
					$dayNotes[$y] = "&nbsp;";
				}
			}
			
			// write table
			$query = "SELECT periodTime FROM ".DBPREFIX."module_calendar_style WHERE id = '2' LIMIT 1";
			$objResult = $objDatabase->Execute($query);
			
			$period = explode(" ", $objResult->fields['periodTime']);
			
			for($x = $period[0]; $x < $period[0] + round(($period[1]-$period[0]+1)/2); $x++){
				$y  = intval($x);
				$x2 = $x + round(($period[1] - $period[0] + 1) / 2);
				$y2 = intval($x2);
				
				if($x < 10){
					$x  = str_pad($x, 2, "0", STR_PAD_LEFT);
				}
				if($x2 < 10){
					$x2 = str_pad($x2, 2, "0", STR_PAD_LEFT);
				}
				
				if($x2 > $period[1]){
					$this->_objTpl->setVariable(array(
				        'CALENDAR_TIME_A_X'       => $this->calDate2.$x,
				        'CALENDAR_TIME_X'         => $x.":00",
				        'CALENDAR_TIME_X_ROW1'    => $dayNote[$y],
				        'CALENDAR_TIME_A_Y'       => $this->calDate2.$x2,
				        'CALENDAR_TIME_Y'         => "&nbsp;",
				        'CALENDAR_TIME_Y_ROW1'    => "&nbsp;",
				        'CALENDAR_TIME_X_ROW2'    => $dayNotes[$y],
				        'CALENDAR_TIME_Y_ROW2'    => "&nbsp;"
			        ));
				} else {
				    $this->_objTpl->setVariable(array(
				        'CALENDAR_TIME_A_X'       => $this->calDate2.$x,
				        'CALENDAR_TIME_X'         => $x.":00",
				        'CALENDAR_TIME_X_ROW1'    => $dayNote[$y],
				        'CALENDAR_TIME_A_Y'       => $this->calDate2.$x2,
				        'CALENDAR_TIME_Y'         => $x2.":00",
				        'CALENDAR_TIME_Y_ROW1'    => $dayNote[$y2],
				        'CALENDAR_TIME_X_ROW2'    => $dayNotes[$y],
				        'CALENDAR_TIME_Y_ROW2'    => $dayNotes[$y2]
			        ));
				}
				$this->_objTpl->parse("rows");
			}
			
		}
		}
		
		// month view
		if(!isset($_GET['day']) && isset($_GET['month']) && isset($_GET['year'])){
			$i = 0;
		    $this->_objTpl->setVariable(array(
		            'START_ROWS'        => '<!-- ',
		            'END_ROWS'          => ' -->',
			        'START_EVENT'       => '',
			        'END_EVENT'         => '',
			        'START_ROWS2'       => '',
			        'END_ROWS2'         => '',
			        'START_ROWS3'       => '<!-- ',
			        'END_ROWS3'         => ' -->'
		    ));
			
			$sort     = intval($_GET['year']).$_GET['month']."01";
            $end_sort = intval($_GET['year']).$_GET['month']."31";
			
			$query = "SELECT id,
			                   catid,
			                   date,
			                   time,
			                   name
			              FROM ".DBPREFIX."module_calendar
			             WHERE sort BETWEEN ".intval($sort)." AND ".intval($end_sort)."
			                   ".$catslang."
			          ORDER BY sort ASC,
			                   time ASC,
			                   priority ASC,
			                   id ASC";
			
			$objResult = $objDatabase->Execute($query);
		
			// write table
			if ($objResult !== false) {
				while(!$objResult->EOF) {	
					$class = ($i % 2) ? "calendar2" : "calendar1";				
					$date    = substr($objResult->fields['date'], 3, 2).".".substr($objResult->fields['date'], 0, 2).".".substr($objResult->fields['date'], 6, 4);
					$time    = substr($objResult->fields['time'], 0, 2).":".substr($objResult->fields['time'], 2, 2);
					
					$link  = "?section=calendar&month=".substr($objResult->fields['date'], 0, 2);
					$link .= "&day=".substr($objResult->fields['date'], 3, 2)."&year=".substr($objResult->fields['date'], 6, 4);
					$link2 = "?section=calendar&cmd=note&id=".$objResult->fields['id'];
		
					$this->_objTpl->setVariable(array(
					    'CALENDAR_CLASS'     => $class,
					    'CALENDAR_LINK'      => $link,
					    'CALENDAR_DATE'      => $date,
					    'CALENDAR_TIME'      => $time,
					    'CALENDAR_LINK2'     => $link2,
					    'CALENDAR_NAME'      => $objResult->fields['name'],
					    'CALENDAR_CAT'       => $this->arrCategories[$objResult->fields['catid']]['name']
					));
					
					$this->_objTpl->parse("rows2");
					$i++;
					$objResult->MoveNext();
				}
			}
			
			if($i == 0){
				$this->_objTpl->setVariable('CALENDAR_EVENT', $_ARRAYLANG['TXT_CALENDAR_EVENTS_NO']);
			    $this->_objTpl->setVariable(array(
				        'START_ROWS2'       => '<!-- ',
				        'END_ROWS2'         => ' -->'));
			}else{
				$this->_objTpl->setVariable('CALENDAR_EVENT', $_ARRAYLANG['TXT_CALENDAR_EVENTS'].": $i");
			}
			
			$this->_objTpl->parse("event");
		}
			
		$this->_objTpl->setVariable(array(
			'CALENDAR_DATE'		=> $this->calendarDay
		));
		
		$java_script  = "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\nfunction goTo()\n{\nwindow.location.href = \"?section=calendar&catid=".$_GET['catid']."&month=\"+document.goToForm.goToMonth.value+\"&year=\"+document.goToForm.goToYear.value;\n}\n\n\n";
		$java_script .= "function categories()\n{\nwindow.location.href = \"".$requestUri."&catid=\"+document.selectCategory.inputCategory.value;\n}\n// -->\n</script>";
		
	    // parse remains to template
		$this->_objTpl->setVariable(array(
			'CALENDAR'			=> $this->calendarMonth,
			'JAVA_SCRIPT'       => $java_script
		));
		return $this->_objTpl->get();
	}

	
	
    // CASE NOTE
	function showDayNote(){
		if(!isset($_GET['id'])){
			echo "<script type='text/javascript' type=\"text/javascript\">\n";
			echo "    location.replace('?section=calendar')\n";
			echo "</script>\n";
		}
		$this->_objTpl->setTemplate($this->pageContent);
		$this->getDayNote($_GET['id']);		
		return $this->_objTpl->get();
	}
	
	
	
	function categoryInfo() {
		global $objDatabase;		
		$query = "SELECT id,name,status,lang,pos FROM ".DBPREFIX."module_calendar_categories";
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			while(!$objResult->EOF) {
				$this->arrCategories[$objResult->fields['id']] = array(
				    'name' => $objResult->fields['name'],
				    'status' => $objResult->fields['name'], 
				    'lang' => $objResult->fields['lang'],
				    'pos' => $objResult->fields['pos']);
				    
				$objResult->MoveNext();
			}
		}
	}
}
?>