<?php
/**
* Modul Feed
*
* News Syndication Class to manage XML feeds
*
* @copyright     CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author        Ivan Schmid <ivan.schmid@astalavista.ch>
* @author        Paulo M. Santos <pmsantos@astalavista.net>     
* @module        NewsFeed
* @modulegroup   modules 
**/

// SECURITY CHECK
if (eregi('index.class.php', $_SERVER['PHP_SELF'])) {
    header('Location: index.php');
    die();
}
	
//error_reporting(E_ALL);
require_once ASCMS_LIBRARY_PATH . '/PEAR/XML/RSS.class.php';
require_once ASCMS_MODULE_PATH . '/feed/feedLib.class.php';

if(ini_get('allow_url_fopen') != 1){
	@ini_set('allow_url_fopen', '1');
	if(ini_get('allow_url_fopen') != 1){
		die("Please set the variable 'allow_url_fopen' to the value 1");
	}
}

class feed extends feedLibrary{
	var $_objTpl;
	var $pageTitle;
	var $statusMessage;
	var $feedpath;
	
    // CONSTRUCTOR
    function feed($pageContent) {
	    global  $_ARRAYLANG;
	    $this->pageContent = $pageContent;
		$this->_objTpl = &new HTML_Template_Sigma('.');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
	}	
    
	// GET PAGE
    function getFeedPage() {
    	$this->showNews();
    	return $this->_objTpl->get(); 
    }
    

	
	function showNews() {
		global $objDatabase, $_ARRAYLANG, $_LANGID;
		
		$this->_objTpl->setTemplate($this->pageContent, true, true);
		
		//feed path
		$this->feedpath = ASCMS_FEED_PATH . '/';
		
		//active (with $_LANGID) categories
		$query = "SELECT id,
		                   name
		              FROM ".DBPREFIX."module_feed_category
		             WHERE status = '1'
		               AND lang = '".$_LANGID."'
		          ORDER BY pos";
		if(($objResult = $objDatabase->Execute($query)))

		while (!$objResult->EOF) {
			$cat_id[$objResult->fields['id']]   = $objResult->fields['id'];
			$cat_name[$objResult->fields['id']] = $objResult->fields['name'];
			$objResult->MoveNext();
		}
		
		
		//active news
		$query = "SELECT id,
		                   subid,
		                   name
		              FROM ".DBPREFIX."module_feed_news
		             WHERE status = '1'
		          ORDER BY pos";
		$objResult = $objDatabase->Execute($query);
		
		while (!$objResult->EOF) {
			$news_subid[$objResult->fields['subid']][$objResult->fields['id']] = $objResult->fields['subid'];
			$news_id[$objResult->fields['subid']][$objResult->fields['id']]    = $objResult->fields['id'];
			$news_name[$objResult->fields['subid']][$objResult->fields['id']]  = $objResult->fields['name'];
			$objResult->MoveNext();
		}
		
		//no empty categories
		if(is_array($cat_id)){
			foreach($cat_id as $x){
				if(!isset($news_id[$x])){
					unset($cat_id[$x]);
					unset($cat_name[$x]);
				}
			}
		}
		
		if(count($cat_id) == 0){
			unset($cat_id);
		}
		
		//output structure
		if(!is_array($cat_id)){
			if(!isset($_GET['cat']) and !isset($_GET['news'])){
				$this->_objTpl->setVariable('FEED_NO_NEWSFEED', $_ARRAYLANG['TXT_FEED_NO_NEWSFEED']);
			}else{
				header("Location: index.php?section=feed");
			}
		} else {		
			foreach($cat_id as $x){
				//out cat
				$this->_objTpl->setVariable('FEED_CAT_NAME', $cat_name[$x]);
				
				//out news
				foreach($news_id[$x] as $y){
					$this->_objTpl->setVariable(array(
					    'FEED_NEWS_LINK'   => '?section=feed&amp;cat='.$news_subid[$x][$y].'&amp;news='.$news_id[$x][$y],
					    'FEED_NEWS_NAME'   => strip_tags($news_name[$x][$y])
					));
					$this->_objTpl->parse('feed_news');
				}
				$this->_objTpl->parse('feed_cat');
			}
		
			// first access
			if(!isset($_GET['cat']) and !isset($_GET['news'])){
				reset($cat_id);
				$_GET['cat'] = current($cat_id);
				reset($news_id[$_GET['cat']]);
				$_GET['news'] = current($news_id[$_GET['cat']]);
				/*
				foreach($cat_id as $x)
				{
					$_GET['cat'] = $cat_id[$x];
					
					foreach($news_id[$x] as $y)
					{
						$_GET['news'] = $news_id[$x][$y];
						break;
					}
					break;
				}*/
			}
			
			$getCat  = intval($_GET['cat']);
			$getNews = intval($_GET['news']);
			
			//refresh control
			$query = "SELECT time,
		                       cache
		                  FROM ".DBPREFIX."module_feed_news
			             WHERE id = '".$getNews."'
			               AND subid = '".$getCat."'
		                   AND status = '1'";
			$objResult = $objDatabase->Execute($query);
			if($objResult->RecordCount() == 0){
				header("Location: index.php?section=feed");
				die;
			}
			
			
			$old_time = $objResult->fields['time'] + $objResult->fields['cache'];
			$time = time();
			
			if($time >= $old_time){
				$this->showNewsRefresh($getNews, $time, $this->feedpath);
			}
			
			$query = "SELECT name,
		                       filename,
		         FROM_UNIXTIME(time, '%d. %M %Y, %H:%i') AS time,
		                       articles,
		                       image
			              FROM ".DBPREFIX."module_feed_news
			             WHERE id = '".$getNews."'
			               AND subid = '".$getCat."'
		                   AND status = '1'";
			$objResult = $objDatabase->Execute($query);
			
			//output selected news
			$news_name = $objResult->fields['name'];
			
			$this->_objTpl->setVariable(array(
			    'FEED_CAT'    => $cat_name[$getCat],
			    'FEED_PAGE'   => $news_name
			));
			
			$filename = $this->feedpath.$objResult->fields['filename'];
			
			//rss class
			$rss =& new XML_RSS($filename);
			$rss->parse();
			
			//channel info
			$info = $rss->getChannelInfo();
			
			$out_title = strip_tags($info['title']);
			$out_time  = strip_tags($objResult->fields['time']);
						
			//image
			foreach ($rss->getImages() as $img) {
				if($img['url'] != '' && $objResult->fields['image'] == 1) {
					$out_image = '<img src="'.strip_tags($img['url']).'" alt="" /><br />';
				}
			}
			
			
			$this->_objTpl->setVariable(array(
			    'FEED_IMAGE'            => $out_image,
			    'FEED_TITLE'            => $out_title,
			    'FEED_TIME'             => $out_time,
			    'TXT_FEED_LAST_UPTDATE' => $_ARRAYLANG['TXT_FEED_LAST_UPDATE']
			));
			
			//items
			$x = 0;
			foreach ($rss->getItems() as $value){
				if($x < $objResult->fields['articles']){
					$this->_objTpl->setVariable(array(
					    'FEED_LINK'   => strip_tags($value['link']),
					    'FEED_NAME'   => strip_tags($value['title'])
					));
					
					$this->_objTpl->parse('feed_output_news');				
					$x++;
				}
			}
			
			$this->_objTpl->parse('feed_show_news');
		}
	}
}
?>