<?PHP
/**
* Modul Newsletter
*
* Different functions to manage the newsletter
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Ivan Schmid <ivan.schmid@astalavista.ch>  
* @author  Leandro Nery <nery@astalavista.net>   
* @module newsletter
* @modulegroup modules
* @access public 
* @version 1.0.1    
*/

class newslettermanager
{
    var $statusMessage;
    var $_NEWSLETTER_CONFIG = array();
    var $attachmentPath;
    var $_objTpl;    
    var $newsletterUri;  // unsubscribe/subscribe URI part   
    
    /**
    * Constructor
    *
    * @param  string  
    * @access public
    */    
    function newslettermanager (){
    	global $_ARRAYLANG, $objTemplate;
    	
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/newsletter/template');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
    	
    	$this->attachmentPath = ASCMS_NEWSLETTER_ATTACH_PATH . '/'; 
    	
    	// example: http://www.contrexx.com/demo ( without slash )		
		$this->newsletterUri = strtolower(ASCMS_PROTOCOL)."://".$_SERVER['HTTP_HOST'].ASCMS_PATH_OFFSET;	
    	
    	$objTemplate->setVariable("CONTENT_NAVIGATION","<a href='?cmd=newsletter&amp;act=stats'>[".$_ARRAYLANG['TXT_NEWSLETTER_OVERVIEW']."]</a>
    											 <a href='?cmd=newsletter&amp;act=listinsert'>[".$_ARRAYLANG['TXT_CREATE_LIST']."]</a>
    											 <a href='?cmd=newsletter&amp;act=news'>[".$_ARRAYLANG['TXT_NEWS_MESSAGES']."]</a>
    	                                         <a href='?cmd=newsletter&amp;act=settings'>[".$_ARRAYLANG['TXT_SETTINGS']."]</a>");
    	
		$objTemplate->setVariable("CONTENT_TITLE",$_ARRAYLANG['TXT_NEWSLETTER']);
		$this->init_settings();
		
    }
      
    
    function getNewsletterPage() {
    	global $_ARRAYLANG, $objTemplate;
   	    	
        switch($_GET['act']){		
			case "news":		
                $this->getNewsPage($pageContent);
			break;
			
			case "code":
			    $this->showCode($pageContent);
			break;
			
			case "settings":
                $this->settings($pageContent);
			break;
						
			case "edituser":
			    $this->getEditUserPage($pageContent);
			break;
												
			case "showuser":										
				$this->getUserPage($pageContent);
			break;	
	
			case "sendnewsletter":
			    $this->sendNewsletter($pageContent);
			break;			
				
			case "listinsert":
			    $this->listInsert($pageContent);
			break;
						
			case "listedit":
			    $this->listEdit($pageContent);
			break;					
			    						    				    		    
			case "import":
			    $this->import($pageContent);
			break;
			    			    
            case "export":
                $this->export($pageContent);
			break;
                                
            case "archive":
                $this->archive($pageContent);
			break;
									
			case "archiveadd":
                $this->archive_add($pageContent);
			break;	
								
			case "archiveedit":
                $this->archive_edit($pageContent);
			break;
												
			default:
				$this->getStats($pageContent);
		}
		
		$objTemplate->setVariable(array(
			'CONTENT_STATUS_MESSAGE'	=> ltrim($this->statusMessage),
			'ADMIN_CONTENT'				=> $this->_objTpl->get()
		));
    }
	
    // newsletter functions     
   
    function init_settings(){ 
    	global $_ARRAYLANG, $db;
    	$db->query("SELECT * FROM ".DBPREFIX."newsletter_settings");							
		while($db->next_record()){
    		$this->_NEWSLETTER_CONFIG[$db->f("setname")]=$db->f("setvalue");
		}
    }
    
    
    
    
    function showCode() {    
    	global $_ARRAYLANG;	
    	$this->_objTpl->loadTemplateFile('newsletter_code.html');
    	
		$this->_objTpl->setVariable(array(
		    'TXT_NEWSLETTER_HTML_CODE' => $_ARRAYLANG['TXT_NEWSLETTER_HTML_CODE'],
			'TXT_SELECT_ALL'           => $_ARRAYLANG['TXT_SELECT_ALL'],
			'TXT_EMAIL_ADRESS'         => $_ARRAYLANG['TXT_EMAIL_ADDRESS']
		)); 
		
		$this->parseNavBar(intval($_GET['listId']));
		$this->_objTpl->setVariable("NEWSLETTER_CODE_LISTID",$_GET['listId']);
	}						

	
	function listInsert() {
    	global $_ARRAYLANG;
    	$this->_objTpl->loadTemplateFile('newsletter_list_insert.html');
	  			
		$this->_objTpl->setVariable(array(
                'TXT_LIST'                         => $_ARRAYLANG['TXT_LIST'],
                'TXT_WILDCART_INFOS'               => $_ARRAYLANG['TXT_WILDCART_INFOS'],
                'TXT_NEWSLETTER_CONFIRMATION_TEXT' => $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_TEXT'],
                'TXT_UNSUBSCRIBE_NEWSLETTER'       => $_ARRAYLANG['TXT_UNSUBSCRIBE_NEWSLETTER'],
                'TXT_LIST_NAME'                    => $_ARRAYLANG['TXT_LIST_NAME'],
                'TXT_SENDER'                       => $_ARRAYLANG['TXT_SENDER'],
                'TXT_HEADER'                       => $_ARRAYLANG['TXT_HEADER'],
                'TXT_FOOTER'                       => $_ARRAYLANG['TXT_FOOTER'],
                'TXT_TITLE'                        => $_ARRAYLANG['TXT_TITLE'],
                'TXT_CONFIRMATION'                 => $_ARRAYLANG['TXT_CONFIRMATION'],
                'TXT_CONFIRMATION_TITLE'           => $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION'],
                'TXT_MUST_CONFIRM_NEWSLETTER'      => $_ARRAYLANG['TXT_NEWSLETTER_MUST_CONFIRM'],                
                'TXT_TEXT'                         => $_ARRAYLANG['TXT_TEXT'],
                'TXT_WELCOME'                      => $_ARRAYLANG['TXT_WELCOME'],
                'TXT_WELCOME2NEWSLETTER'           => $_ARRAYLANG['TXT_NEWSLETTER_WELCOME'],
                'TXT_WELCOME_MESSAGE'              => $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_SUCCESSFUL'],                    
                'TXT_EDIT_LIST'                    => $_ARRAYLANG['TXT_EDIT_LIST'],
                'TXT_INSERT_LIST'                  => $_ARRAYLANG['TXT_INSERT_LIST'],
                'TXT_CLEAR_FORM'                   => $_ARRAYLANG['TXT_CLEAR_FORM'], 
                'TXT_FIELD_REQUIRED'               => $_ARRAYLANG['TXT_FILL_OUT_ALL_REQUIRED_FIELDS'], 
                'TXT_ALL_FIELDS_REQUIRED'          => $_ARRAYLANG['TXT_ALL_FIELDS_REQUIRED']
      	)); 										
      	
      	(empty($this->_NEWSLETTER_CONFIG['newsletterSenderEmail'])) ? $newslettersenderemail="Your e-mail address" : $newslettersenderemail=$this->_NEWSLETTER_CONFIG['newsletterSenderEmail'];
		$this->_objTpl->setVariable('TXT_MAILING_LIST_ADDRESS', $newslettersenderemail);
	}						


	
	function settings(){
    	global $_ARRAYLANG, $db;
    	$this->_objTpl->loadTemplateFile('newsletter_settings.html');
	  			
    	if ($_GET["op"]=="update"){    		    				    						
			if($this->updateSettings())	{		
			    $this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_UPDATED_SUCCESSFUL'];
			}else{
				$this->statusMessage= $_ARRAYLANG['TXT_DATABASE_ERROR'];
			}	
    	}
    	 	
		$this->_objTpl->setVariable(array(
                'TXT_SYSTEM_VARIABLES_OVERVIEW' => $_ARRAYLANG['TXT_SETTINGS'],
        		'TXT_VALUE'                     => $_ARRAYLANG['TXT_VALUE'],
	    		'TXT_SAVE_CHANGES'              => $_ARRAYLANG['TXT_SAVE_CHANGES'],
	    		'TXT_DESCRIPTION'               => $_ARRAYLANG['TXT_DESCRIPTION']
      	)); 

		$db->query("SELECT * FROM ".DBPREFIX."newsletter_settings ORDER BY setid");
		$i=0;		
		while($db->next_record()){
			if (($i % 2) == 0){$class="row1";} else{$class="row2";}									
			$this->_objTpl->setVariable("SETTINGS_ROWCLASS",$class);
			
			if (strlen($db->f('setvalue'))>250){
				$setValueField = "<textarea name=\"setvalue[".$db->f('setid')."]\" cols='70' wrap='VIRTUAL' rows='4' >".$db->f('setvalue')."</textarea>";
			}else{		
	            $setValueField = "<input type=\"text\" name=\"setvalue[".$db->f('setid')."]\" value=\"".$db->f('setvalue')."\" size='70' maxlength='250'>";			
			}
			$description = $db->f('setdescription');			
					
			$this->_objTpl->setVariable(array(
				'SETTINGS_SETVALUE'		=> $setValueField,
				'SETTINGS_DESCRIPTION'	=> $_ARRAYLANG[$description]
			));

			$this->_objTpl->parse('settingsOutput');
			$i++;
		}
	}		
		
	
	function updateSettings()
	{
		global $db;
		if (!empty($_POST['setvalue'])){
			foreach ($_POST['setvalue'] as $id => $value) {
				$value = htmlspecialchars(strip_tags($value));
				$db->query("UPDATE ".DBPREFIX."newsletter_settings SET setvalue='$value' WHERE setid=".intval($id));				
			}
			return true;
		} else{
			return false;
		}
	}
	
	
	function listEdit(){
    	global $_ARRAYLANG;
    	$this->_objTpl->loadTemplateFile('newsletter_list_edit.html');
    	if(!empty($_GET['listId'])){
			$this->_objTpl->setVariable(array(
                'TXT_LIST'                         => $_ARRAYLANG['TXT_LIST'],
                'TXT_WILDCART_INFOS'               => $_ARRAYLANG['TXT_WILDCART_INFOS'],
                'TXT_NEWSLETTER_CONFIRMATION_TEXT' => $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_TEXT'],
                'TXT_UNSUBSCRIBE_NEWSLETTER'       => $_ARRAYLANG['TXT_UNSUBSCRIBE_NEWSLETTER'],
                'TXT_LIST_NAME'                    => $_ARRAYLANG['TXT_LIST_NAME'],
                'TXT_SENDER'                       => $_ARRAYLANG['TXT_SENDER'],
                'TXT_HEADER'                       => $_ARRAYLANG['TXT_HEADER'],
                'TXT_FOOTER'                       => $_ARRAYLANG['TXT_FOOTER'],
                'TXT_TITLE'                        => $_ARRAYLANG['TXT_TITLE'],
                'TXT_CONFIRMATION'                 => $_ARRAYLANG['TXT_CONFIRMATION'],
                'TXT_TEXT'                         => $_ARRAYLANG['TXT_TEXT'],
                'TXT_WELCOME'                      => $_ARRAYLANG['TXT_WELCOME'],
                'TXT_EDIT_LIST'                    => $_ARRAYLANG['TXT_EDIT_LIST'],
                'TXT_FIELD_REQUIRED'               => $_ARRAYLANG['TXT_FILL_OUT_ALL_REQUIRED_FIELDS'], 
                'TXT_ALL_FIELDS_REQUIRED'          => $_ARRAYLANG['TXT_ALL_FIELDS_REQUIRED']
            ));
            
            $this->parseNavBar(intval($_GET['listId']));
            
			$outInformation=$this->getListDetails(0);
			$this->_objTpl->setVariable(array(
				'NEWSLETTER_LIST_EDIT_ID'			=> $outInformation["listid"],
				'NEWSLETTER_LIST_EDIT_NAME'			=> $outInformation["listname"],
				'NEWSLETTER_LIST_EDIT_MAILFROM'		=> $outInformation["listemailfrom"],
				'NEWSLETTER_LIST_EDIT_HEADER'		=> $outInformation["listheader"],
				'NEWSLETTER_LIST_EDIT_FOOTER'		=> $outInformation["listfooter"],
				'NEWSLETTER_LIST_EDIT_WELCOMEMSG'	=> $outInformation["listwelcomemsg"],
				'NEWSLETTER_LIST_EDIT_VALIDMSG'		=> $outInformation["listvalidmsg"],
				'NEWSLETTER_LIST_EDIT_WELCOMEMSGTITLE'	=> $outInformation["listwelcomemsgtitle"],
				'NEWSLETTER_LIST_EDIT_VALIDMSGTITLE'	=> $outInformation["listvalidmsgtitle"]
			));
		}
	}		
			
			
	function import()
    {
    	global $_ARRAYLANG;
    	$this->_objTpl->loadTemplateFile('newsletter_import.html');
	  			
		$this->_objTpl->setVariable(array(
             'TXT_ENTER_EMAIL_ADDRESS' => $_ARRAYLANG['TXT_ENTER_EMAIL_ADDRESS'],
		     'TXT_IMPORT'              => $_ARRAYLANG['TXT_IMPORT']
      	)); 
      	
		$this->parseNavBar(intval($_GET['listId']));
      	$this->_objTpl->setVariable("NEWSLETTER_IMPORT_LISTID",intval($_GET['listId']));
	}
	
	
	   

	function export()
    {
    	global $_ARRAYLANG;
    	$array_export=array();
    	$this->_objTpl->loadTemplateFile('newsletter_export.html');
	  			
		$this->_objTpl->setVariable(array(
			'TXT_CHOOSE_SEPERATOR'   => $_ARRAYLANG['TXT_CHOOSE_SEPERATOR'],
			'TXT_CREATE_EXPORT_LIST' => $_ARRAYLANG['TXT_CREATE_EXPORT_LIST']
      	)); 
      	
      	$this->parseNavBar(intval($_GET['listId']));
      	
      	if ($_GET['op'] == "selected"){
	    	$array_users=explode(",",$_POST['formusers']);
	    	foreach ($array_users as $value){
			    if ($_POST["checkEmailId".$value]==$value){
			    	$array_export[]=$value;				    	
			    }
	        }	
	    }

	    $this->_objTpl->setVariable("NEWSLETTER_EXPORT_LISTID",$_GET["listId"]);  	
        if (!empty($array_export))
        {
        	$this->_objTpl->setVariable("NEWSLETTER_EXPORT_ARRAY",implode(",",$array_export));
        }
        else 
        {
        	if ($_GET['op'] == "selected") $this->_objTpl->setVariable("NEWSLETTER_EXPORT_ARRAY","-1");
        }
        
        if(!empty($_POST['splitchar']))
        {
        	$this->_objTpl->setVariable("NEWSLETTER_EXPORT_TEXTAREA", $this->exportAddresses());
        }
	}
	  
	
	
	function archive()
    {
    	global $db, $_ARRAYLANG, $_CONFIG;
    
    	$this->_objTpl->loadTemplateFile('newsletter_archiv.html');
		
    	$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_LIST'        => $_ARRAYLANG['TXT_NEWSLETTER_LIST'],	
			'TXT_TITLE'                  => $_ARRAYLANG['TXT_TITLE'],
			'TXT_FROM'                   => $_ARRAYLANG['TXT_FROM'],
			'TXT_ACTION'                 => $_ARRAYLANG['TXT_ACTION'],
			'TXT_SEARCH'                 => $_ARRAYLANG['TXT_SEARCH'],
			'TXT_MAIL'                   => $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
			'TXT_DATE'                   => $_ARRAYLANG['TXT_DATE'],
			'TXT_ARCHIVE_SEARCH'         => $_ARRAYLANG['TXT_ARCHIVE_SEARCH'],
			'TXT_CONFIRM_DELETE_DATA'    => $_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'],
		    'TXT_ACTION_IS_IRREVERSIBLE' => $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE'], 			    
		    'TXT_EDIT'                   => $_ARRAYLANG['TXT_EDIT'], 	
		    'TXT_DELETE'                 => $_ARRAYLANG['TXT_DELETE'], 
		    'TXT_ATTACHMENT'	           => $_ARRAYLANG['TXT_ATTACHMENT'], 
		    'TXT_OPTIONS'                => $_ARRAYLANG['TXT_OPTIONS'], 
		    'TXT_ASNEW'                  => $_ARRAYLANG['TXT_STORE_AS_NEW_TEMPLATE']
      	));   
      	    		            	
		if($_POST['insert']!=""){
			$this->statusMessage= $this->archivInsert();
		}		
		if($_POST['update']!=""){			
			 $this->statusMessage= $this->archivUpdate();
		}
		if($_GET['op']=="delete"){
			if($delete = $this->archivDelete())
			 $this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
			else 
			 $this->statusMessage= $_ARRAYLANG['TXT_SUBMIT_ERROR'];
		}
			
		$archivid= $_GET['archivid'];
		$archivlistid= intval($_GET['archivlistid']);	
		$this->parseNavBar($archivlistid);	
		$pos= intval($_GET['pos']);				
						
		$arraylist=$this->getListDetails($archivlistid);
		
		$this->_objTpl->setVariable('TXT_ARCHIVE',$arraylist['listname']); //$_ARRAYLANG['txtArchive'].": "
      	
		if($archivlistid!=""){
			$term= htmlspecialchars($_REQUEST['term']);
			if ($term!="") {
			    $query="SELECT * FROM ".DBPREFIX."newsletter_archiv WHERE archivsubject LIKE '%".$term."%' OR archivfromemail LIKE '%".$term."%' OR archivfromname LIKE '%".$term."%' ORDER BY archivdate DESC";
			}			
			else 
			{
				$query="SELECT * FROM ".DBPREFIX."newsletter_archiv WHERE archivlistid=$archivlistid ORDER BY archivdate DESC";		
			}			
												
			////// paging start /////////		
			$db->query($query);		
			$count= $db->num_rows();
			if(!is_numeric($pos)){
			  $pos= 0;
		    }
		    if ($count>intval($_CONFIG['corePagingLimit'])){	    
				$paging= getPaging($count, $pos, "&cmd=newsletter&act=archive&archivlistid=".$archivlistid, "<b>Eintrge</b>", true);
		    }
			////// paging end /////////
		
		    $pagingLimit= intval($_CONFIG['corePagingLimit']);
		    $db->query("$query LIMIT $pos, $pagingLimit");	 
		    
			while($db->next_record())
			{
				($i % 2)? $class = "row2" : $class = "row1";
			    $i++;		
			    
			    $fullpath= str_replace("//","/",$this->attachmentPath);
				$file_array= $this->read_directory($fullpath,$db->f('archivid')); 
			    $attachment="";
			    if (!empty($file_array))
			    {
				    for ($j=0;$j<count($file_array) && j<5;$j++)
				    {
				        $attachment.="<a href='".ASCMS_NEWSLETTER_ATTACH_WEB_PATH . '/' .$file_array[$j]."' target=new><img src='images/icons/clip.gif' border=0 alt='".str_replace($db->f('archivid')."_","",$file_array[$j])."' /></a>";				    	
				    }			    			     
			    }
			    if (empty($attachment)) $attachment="-";  
			    
			    $priority= intval($db->f("archivpriority"));
			    switch ($priority)
			    {
			    	case "1": $priorityicon="<img src='images/icons/priority2h.gif' />"; break;
			    	case "2": $priorityicon="<img src='images/icons/priorityh.gif' />"; break;
			    	case "4": $priorityicon="<img src='images/icons/priorityl.gif' />"; break;
			    	case "5": $priorityicon="<img src='images/icons/priority2l.gif' />"; break;
			    	default: $priorityicon="";
			    }
			     
				$this->_objTpl->setVariable(array(
				      'NEWSLETTER_SHOWUSER_CLASS'       => $class,
					  'NEWSLETTER_ARCHIVE_ID'     	    => $db->f('archivid'),
					  'NEWSLETTER_ARCHIVE_FROM'  		=> $db->f('archivfromname'),
					  'NEWSLETTER_ARCHIVE_EMAIL'  	    => $db->f('archivfromemail'),
					  'NEWSLETTER_ARCHIVE_TITLE'  	    => $db->f('archivsubject'),	
					  'NEWSLETTER_ARCHIVE_DATE'   	    => $db->f('archivdate'),
					  'NEWSLETTER_ARCHIVE_PRIORITY'     => $priorityicon,
					  'NEWSLETTER_ARCHIVE_ATTACHMENT'   => $attachment 	
				));	
				$this->_objTpl->parse("row");
			}
			if (!isset($i)) {
				$this->_objTpl->hideBlock('row');
			}
		}	
				
		$this->_objTpl->setVariable(array(
			'NEWSLETTER_ARCHIVE_PAGING'		=> $paging,
			'NEWSLETTER_ARCHIVE_LISTID'		=> $archivlistid
		));
	}

	
	
	
	
	function read_directory($dir,$archivid)
	{				
		$file_array=array();
		
		if (is_dir($dir))
		{
			$fd = @opendir($dir);
			while (($file = @readdir($fd)) == true)
			{		
				$namearray=explode("_",$file);	
				if ($file!="." && $file!=".." && $namearray[0]==$archivid){				
					$file_array[]= $file; 	
				}
				clearstatcache(); 
			} 
			if ($fd == true){
			  	closedir($fd); 
			}
			
			if (!empty($file_array)) {					 
				asort($file_array); 				
				return $file_array; 				
			}		  
			else{		
		  		return false;
			}
		} 
		else {		
			return false; 
		}
	}
		

	
	
	
	function archive_edit()
    {
    	global $db, $_ARRAYLANG, $_CONFIG;
    
    	$this->_objTpl->loadTemplateFile('newsletter_archiv_edit.html');
		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_LIST'         => $_ARRAYLANG['TXT_NEWSLETTER_LIST'],
			'TXT_SAVE_ACTUAL'             => $_ARRAYLANG['TXT_SAVE_ACTUAL'],
			'TXT_TITLE'                   => $_ARRAYLANG['TXT_TITLE'],
			'TXT_FROM'                    => $_ARRAYLANG['TXT_FROM'],
			'TXT_TEXT'                    => $_ARRAYLANG['TXT_TEXT'],	
			'TXT_UPLOAD_FILE'         	=> $_ARRAYLANG['TXT_UPLOAD_FILE'],
			'TXT_ATTACHMENT'              => $_ARRAYLANG['TXT_ATTACHMENT'],				
			'TXT_GENERAL_OPTIONS'         => $_ARRAYLANG['TXT_GENERAL_OPTIONS'],
			'TXT_PRIORITY'                => $_ARRAYLANG['TXT_PRIORITY'],		
			'TXT_MAX_SIZE'	            => $_ARRAYLANG['TXT_MAX_SIZE'],		
			'TXT_FORMAT'	                => $_ARRAYLANG['TXT_FORMAT'],		
			'TXT_HTML'	                => $_ARRAYLANG['TXT_HTML'],		
			'TXT_TEXT'	                => $_ARRAYLANG['TXT_TEXT'],	
		    'TXT_FIELD_REQUIRED'          => $_ARRAYLANG['TXT_FILL_OUT_ALL_REQUIRED_FIELDS'], 
            'TXT_ALL_FIELDS_REQUIRED'     => $_ARRAYLANG['TXT_ALL_FIELDS_REQUIRED']
		));  
      	
		$archivid = intval($_GET['archivId']);		
		$archivlistid=  intval($_GET['archivlistid']);	
		$this->parseNavBar($archivlistid);		
		$this->_objTpl->setVariable(array(
			'NEWSLETTER_ARCHIV_LISTID'		=> $archivlistid,
			'NEWSLETTER_ARCHIV_ARCHIVID'	=> $archivid,
			'NEWSLETTER_MAX_SIZE'			=> ini_get('post_max_size')
		));
    	$options_array=array('1'=> $_ARRAYLANG['TXT_HIGHEST'],
			                '2'=> $_ARRAYLANG['TXT_HIGH'],
			                '3'=> $_ARRAYLANG['TXT_NORMAL'],
			                '4'=> $_ARRAYLANG['TXT_LOW'],
			                '5'=> $_ARRAYLANG['TXT_LOWEST']);
					                
    	if ($_REQUEST["delfile"]){  		
    		$fullpath= str_replace("//","/",$this->attachmentPath.$_REQUEST["delfile"]);
			if(is_file($fullpath)) {
				if (@unlink($fullpath)){
				   $this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
				}else 
				{
					if (@ini_get('safe_mode')){
					    $this->statusMessage= $_ARRAYLANG['TXT_SAFE_MODE_ERROR'];	
					} else{
				   		$this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];
					}
				}
			} else {
				$this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];
			}	
    	}
		    	
		if($archivid!=""){			
			$fullpath= str_replace("//","/", $this->attachmentPath);
			$file_array= $this->read_directory($fullpath,$archivid); 
			
			for ($i=1;$i<=($this->_NEWSLETTER_CONFIG[newsletterMaxAttachment]-count($file_array));$i++){
				$attachfile.="<input type='file' name='attach$i' size='40'>";
				if ($i!=($this->_NEWSLETTER_CONFIG[newsletterMaxAttachment]-count($file_array))){
					$attachfile.="<br />";	
				}
			}			
			$this->_objTpl->setVariable("NEWSLETTER_ARCHIV_ATTACHFILE", $attachfile);
			
			if ($file_array == false) {
				$this->_objTpl->setVariable('ATTACHMENT_NO', $_ARRAYLANG['TXT_NO_ATTACHMENT']);
			} else {
		  		$this->_objTpl->setVariable(array(
					'TXT_ACTION'         	    	=> $_ARRAYLANG['TXT_ACTION'],
				    'TXT_DATE'       		    	=> $_ARRAYLANG['TXT_DATE'],
				    'TXT_FILENAME'            	    => $_ARRAYLANG['TXT_FILENAME'],
				    'TXT_SIZE'               		=> $_ARRAYLANG['TXT_FILESIZE'],
				    'TXT_CONFIRM_DELETE_DATA'    	=> $_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'],
					'TXT_ACTION_IS_IRREVERSIBLE'	=> $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE'],
					'TXT_DELETE'                	=> $_ARRAYLANG['TXT_DELETE']
				));
				$j=0;
			
				foreach ($file_array as $file) { 	
					if (($j% 2)==0){$class="row2";}	else{$class="row1";}
					
					$act_path= "$fullpath/$file";
					
					$size= $this->size_format(filesize($act_path));				
					//$size= filesize($act_path);	
							
					if (is_file($act_path) && $act_path!= $_SERVER['PHP_SELF']) {
						$arrayfile=explode(".",$act_path);
						$fileextension=$arrayfile[count($arrayfile)-1];
						$isimage=false;
						switch (strtolower($fileextension))
						{
							case "jpg": case "jpeg": $filetype="jpg.gif"; $isimage=true; break;
							case "zip": $filetype="zip.gif"; break;
							case "gif": $filetype="gif.gif"; $isimage=true; break;
							case "html":case "htm": $filetype="html.gif"; break;
							case "png": $filetype="png.gif"; $isimage=true; break;
							case "txt": $filetype="txt.gif"; break;
							case "doc": $filetype="word.gif"; break;
							case "exe": $filetype="binary.gif"; break;
							case "mp3": $filetype="mp3.gif"; break;
							case "ppt": $filetype="ppt.gif"; break;
							case "rar": $filetype="rar.gif"; break;
							case "wav": $filetype="wav.gif"; break;	
							case "mid": $filetype="mid.gif"; break;	
							case "pdf": $filetype="pdf.gif"; break;	
							case "hlp": $filetype="hlp.gif"; break;	
							case "exe": $filetype="exe.gif"; break;	
							case "avi": case "mpg": case "mpeg": $filetype="avi.gif"; break;	
							case "bmp": $filetype="bmp.gif";$isimage=true; break;	
							case "psd": $filetype="psd.gif"; $isimage=true; break;	
							case "xls": $filetype="xls.gif"; break;	
							case "js": $filetype="js.gif"; break;	
							case "ram": $filetype="ram.gif"; break;	
							case "swf": $filetype="swf.gif"; $isimage=true; break;	
							case "ttf": $filetype="ttf.gif"; break;	
							case "mdb": $filetype="mdb.gif"; break;	
							case "css": $filetype="css.gif"; break;	
							case "java": $filetype="java.gif"; break;	
							case "pcx": $filetype="pcx.gif"; break;	
							case "pcd": $filetype="pcd.gif"; break;	
							case "tga": $filetype="tga.gif"; break;	
							case "tif": $filetype="tif.gif"; $isimage=true; break;	
							case "mov": $filetype="mov.gif"; break;											
							default: $filetype="generic.gif";												
						}

						$scriptpath= str_replace("//","/",( ASCMS_NEWSLETTER_ATTACH_WEB_PATH ."/". $file));   		
					    if ($isimage) // suportted by php getimagesize()
					    {
					    	$arrayImageData= getimagesize($act_path);
					    	$imageinfo="&nbsp;&nbsp;(".$arrayImageData[0]."x".$arrayImageData[1]." pixels)";					    		
					    	$this->_objTpl->setVariable("ATTACHMENT_FILENAME","<a href=\"javascript:openWindow('".$scriptpath."','','width=".($arrayImageData[0]+25).",height=".($arrayImageData[1]+25).",resizable=yes')\">".str_replace($archivid."_","",$file)."</a>$imageinfo");
					    }	
					    else 
					    {
					    	$this->_objTpl->setVariable("ATTACHMENT_FILENAME","<a href='$scriptpath' target=new>".str_replace($archivid."_","",$file)."</a>");
					    }
					    		   
					    $this->_objTpl->setVariable(array(
					    	'ATTACHMENT_ICON'		=> "<img src='".ASCMS_MODULE_IMAGE_WEB_PATH."/media/$filetype'>",
					    	'ATTACHMENT_DATE'		=> date(ASCMS_DATE_FORMAT,filectime($act_path)),
					    	'ATTACHMENT_SIZE'		=> $size,
					    	'ATTACHMENT_DELETE'		=> $file,
					    	'ATTACHMENT_ROWCLASS'	=> $class
					    ));
					}
					$this->_objTpl->parse('newsletterRow');	
					$j++;
				} 
			}
			
			if ($_REQUEST['op']=="reload"){
				if ($_REQUEST['htmlmode']){
					$htmlmode="checked";
					$txtmode="";	
					$body= stripslashes($_REQUEST['html']);
					$wysiwygMode = "active";
				//	$body= str_replace("\n","<br>",$_REQUEST['html']);						
				}
				else {						
					$htmlmode=$wysiwyg="";
					$txtmode="checked";
					include_once(dirname(__FILE__) . '/class.html2text.php');
					$h2t=& new html2text($_REQUEST['html']);
					$body= $h2t->get_text();
					$wysiwygMode = "html";
				}
				
				foreach ($options_array as $key => $value) {
					$priority.="<option value='$key'";
					if ($_REQUEST['priority']==$key) $priority.="selected";
					$priority.=">$value</option>";
			    }	
				
				$this->_objTpl->setVariable(array(				
				      'NEWSLETTER_ARCHIV_ID'            => $archivid,
					  'NEWSLETTER_ARCHIV_FROMNAME'      => $_REQUEST['archivfromname'],
					  'NEWSLETTER_ARCHIV_FROMEMAIL'     => $_REQUEST['archivfromemail'],
					  'NEWSLETTER_ARCHIV_SUBJECT'       => $_REQUEST['archivsubject'],
					  'NEWSLETTER_ARCHIV_BODY'     	  => get_wysiwyg_editor('html', $body, $wysiwygMode),
					  'NEWSLETTER_ARCHIV_HTML_MODE'     => $htmlmode,	
					  'NEWSLETTER_ARCHIV_TEXT_MODE'     => $txtmode,
					  'NEWSLETTER_ARCHIV_PRIORITY'      => $priority			
				));
			}
			else 
			{				
				$db->query("SELECT * FROM ".DBPREFIX."newsletter_archiv WHERE archivid=".$archivid);
				if($db->next_record()){
					foreach ($options_array as $key => $value) {
						$priority.="<option value='$key'";
						if ($db->f('archivpriority')==$key) $priority.="selected";
						$priority.=">$value</option>";
				    }	
				    
				    if ($db->f("archivhtml")) {
				    	$htmlmode="checked";
				    	$wysiwygMode = "active";				    					    	
				    } else {
				    	$txtmode="checked";
				    	$wysiwygMode = "html";
				    }
					    
					$this->_objTpl->setVariable(array(				
					      'NEWSLETTER_ARCHIV_ID'            => $archivid,
						  'NEWSLETTER_ARCHIV_FROMNAME'      => $db->f('archivfromname'),
						  'NEWSLETTER_ARCHIV_FROMEMAIL'     => $db->f('archivfromemail'),
						  'NEWSLETTER_ARCHIV_SUBJECT'       => $db->f('archivsubject'),
						  'NEWSLETTER_ARCHIV_BODY'     	  => get_wysiwyg_editor('html', $db->f('archivbody'), $wysiwygMode),	
						  'NEWSLETTER_ARCHIV_WYSIWYGEDITOR' => $wysiwyg,
						  'NEWSLETTER_ARCHIV_HTML_MODE'     => $htmlmode,	
						  'NEWSLETTER_ARCHIV_PRIORITY'      => $priority,
						  'NEWSLETTER_ARCHIV_TEXT_MODE'     => $txtmode,		
					));
				
				}
			}
		}
	}


	
	
	function archive_add()
    {
    	global $db, $_ARRAYLANG, $_CONFIG;      
        
    	$this->_objTpl->loadTemplateFile('newsletter_archiv_add.html');
 
		$this->_objTpl->setVariable(array(
			'TXT_NEWSLETTER_LIST'        => $_ARRAYLANG['TXT_NEWSLETTER_LIST'],
			'TXT_TITLE'                  => $_ARRAYLANG['TXT_TITLE'],
			'TXT_FROM'                   => $_ARRAYLANG['TXT_FROM'],
			'TXT_OPTIONS'                => $_ARRAYLANG['TXT_OPTIONS'],
			'TXT_TEXT'                   => $_ARRAYLANG['TXT_TEXT'],
			'TXT_SAVE_AS_NEW_NEWSLETTER' => $_ARRAYLANG['TXT_SAVE_AS_NEW_NEWSLETTER'],
			'TXT_ATTACHMENT'             => $_ARRAYLANG['TXT_ATTACHMENT'],
			'TXT_UPLOAD_FILE'            => $_ARRAYLANG['TXT_UPLOAD_FILE'],		
			'TXT_GENERAL_OPTIONS'        => $_ARRAYLANG['TXT_GENERAL_OPTIONS'],
			'TXT_PRIORITY'               => $_ARRAYLANG['TXT_PRIORITY'],	
			'TXT_MAX_SIZE'	           => $_ARRAYLANG['TXT_MAX_SIZE'],			
			'TXT_FORMAT'	               => $_ARRAYLANG['TXT_FORMAT'],		
			'TXT_HTML'	               => $_ARRAYLANG['TXT_HTML'],		
			'TXT_TEXT'	               => $_ARRAYLANG['TXT_TEXT'],	
		    'TXT_FIELD_REQUIRED'         => $_ARRAYLANG['TXT_FILL_OUT_ALL_REQUIRED_FIELDS'], 
            'TXT_ALL_FIELDS_REQUIRED'    => $_ARRAYLANG['TXT_ALL_FIELDS_REQUIRED']
	    )); 
      	   	
		$archivlistid= intval($_REQUEST['listId']);
		$archivid= intval($_REQUEST['archivId']);
		$this->parseNavBar($archivlistid);
				
		$options_array=array('1'=> $_ARRAYLANG['TXT_HIGHEST'],
			                '2'=> $_ARRAYLANG['TXT_HIGH'],
			                '3'=> $_ARRAYLANG['TXT_NORMAL'],
			                '4'=> $_ARRAYLANG['TXT_LOW'],
			                '5'=> $_ARRAYLANG['TXT_LOWEST']);					                

		for ($i=1;$i<=$this->_NEWSLETTER_CONFIG[newsletterMaxAttachment];$i++){
			$attachfile.="<input type='file' name='attach$i' size='40'>";
			if ($i!=$this->_NEWSLETTER_CONFIG[newsletterMaxAttachment]){
				$attachfile.="<br />";	
			}
		}

		$this->_objTpl->setVariable(array(
			'NEWSLETTER_ARCHIV_ATTACHFILE'	=> $attachfile,
			'NEWSLETTER_ARCHIV_LISTID'		=> $archivlistid,
			'NEWSLETTER_MAX_SIZE'			=> ini_get('post_max_size')
		));
		
		if($archivlistid!=""){
			if ($archivid==""){
				if ($_REQUEST['op']=="reload"){
					if ($_REQUEST['htmlmode']){
						$htmlmode="checked";	
						$txtmode="";							
						$body= $_REQUEST['html'];
						$wysiwygMode = "active";				
					}
					else {						
						$htmlmode=$wysiwyg="";
						$txtmode="checked";						
						include_once(dirname(__FILE__).'/class.html2text.php');
						$h2t=& new html2text($_REQUEST['html']);
						$body= $h2t->get_text();
						$wysiwygMode = "html";						
					}
					
					foreach ($options_array as $key => $value) {
						$priority.="<option value='$key'";
						if ($_REQUEST['priority']==$key) $priority.="selected";
						$priority.=">$value</option>";
				    }	
					
					$this->_objTpl->setVariable(array(
					      'NEWSLETTER_ARCHIV_ID'            => $archivid,
						  'NEWSLETTER_ARCHIV_FROMNAME'      => $_REQUEST['archivfromname'],
						  'NEWSLETTER_ARCHIV_FROMEMAIL'     => $_REQUEST['archivfromemail'],
						  'NEWSLETTER_ARCHIV_SUBJECT'       => $_REQUEST['archivsubject'],
						  'NEWSLETTER_ARCHIV_BODY'     	  => get_wysiwyg_editor('html', $body, $wysiwygMode),	
						  'NEWSLETTER_ARCHIV_HTML_MODE'     => $htmlmode,	
						  'NEWSLETTER_ARCHIV_TEXT_MODE'     => $txtmode,
						  'NEWSLETTER_ARCHIV_PRIORITY'      => $priority
					));
				}
				else 
				{				
					$db->query("SELECT listheader, listfooter FROM ".DBPREFIX."newsletter_lists WHERE listid=".$archivlistid);
					if($db->next_record()){
						$txtmode="checked";
						(empty($this->_NEWSLETTER_CONFIG['newsletterSenderName'])) ? $newslettersendername="Your name" : $newslettersendername=$this->_NEWSLETTER_CONFIG['newsletterSenderName'];
						(empty($this->_NEWSLETTER_CONFIG['newsletterSenderEmail'])) ? $newslettersenderemail="Your e-mail address" : $newslettersenderemail=$this->_NEWSLETTER_CONFIG['newsletterSenderEmail'];					
						(empty($this->_NEWSLETTER_CONFIG['newsletterTitle'])) ? $newslettertitle="Newsletter Subject ".strftime(', KW %V-%Y') : $newslettertitle= $this->_NEWSLETTER_CONFIG['newsletterTitle'];																														
						
					    foreach ($options_array as $key => $value) {
							$priority.="<option value='$key'";
							if ($key=='3') $priority.="selected";
							$priority.=">$value</option>";
					    }
					    $nwlBody = stripslashes($db->f("listheader")).str_repeat("\n",5).stripslashes($db->f("listfooter"));						
						$this->_objTpl->setVariable(array(
							'NEWSLETTER_ARCHIV_FROMNAME' => $newslettersendername,
							'NEWSLETTER_ARCHIV_FROMEMAIL' => $newslettersenderemail,
							'NEWSLETTER_ARCHIV_SUBJECT' => $newslettertitle,
							'NEWSLETTER_ARCHIV_BODY' => get_wysiwyg_editor('html', $nwlBody, 'html'),						
							'NEWSLETTER_ARCHIV_PRIORITY' => $priority,
							'NEWSLETTER_ARCHIV_TEXT_MODE' => $txtmode
						));
						unset($nwlBody);
					}
				}
			}
			else
			{
		
				$db->query("SELECT * FROM ".DBPREFIX."newsletter_archiv WHERE archivid=".$archivid);
				if($db->next_record()){
					foreach ($options_array as $key => $value) {
						$priority.="<option value='$key'";
						if ($db->f('archivpriority')==$key) $priority.="selected";
						$priority.=">$value</option>";
				    }	
				    
				    if ($db->f("archivhtml")) {
				    	$htmlmode="checked";
				    	$txtmode="";
				    } else {
				    	$txtmode="checked";
				    }
				    				    
					$this->_objTpl->setVariable(array(
						'NEWSLETTER_ARCHIV_FROMNAME'      => $db->f('archivfromname'),
						'NEWSLETTER_ARCHIV_FROMEMAIL'     => $db->f('archivfromemail'),
						'NEWSLETTER_ARCHIV_SUBJECT'       => $db->f('archivsubject'),
						'NEWSLETTER_ARCHIV_BODY'   	    => $db->f('archivbody'),	
						'NEWSLETTER_ARCHIV_PRIORITY'      => $priority,
						'NEWSLETTER_ARCHIV_HTML_MODE'     => $htmlmode,
						'NEWSLETTER_ARCHIV_TEXT_MODE'     => $txtmode,	
						'NEWSLETTER_ARCHIV_WYSIWYGEDITOR' => $wysiwyg
					));		
				}
				
			}				
		}
	}

	
	
	
	
	function sendNewsletter()
    {
    	global $db, $_ARRAYLANG;
        $options="";
        	
    	$this->_objTpl->loadTemplateFile('newsletter_send.html');
    					
	  	if ($_REQUEST['send']!=""){
			$this->statusMessage= $this->sendmail($_REQUEST['archivid']);
		}													
		
		//$this->statusMessage= $_ARRAYLANG['txtPleaseEnterTestEmailAdress'];
		
		$testmail = $_POST['testmail'];
		if (empty($testmail)){
			$testmail=$this->_NEWSLETTER_CONFIG["newsletterSenderEmail"];
		}
		if (!empty($_POST['test']) && !empty($_POST['archivid'])){			
			$this->statusMessage= $this->sendmail($_POST['archivid'], $testmail);
		}
		
		$archivlistid = intval($_REQUEST['archivlistid']);			
		$this->parseNavBar($archivlistid);
		
		$this->_objTpl->setVariable(array(
			'TXT_ARCHIVE'                => $_ARRAYLANG['TXT_ARCHIVE'],
			'TXT_SEND_NEWSLETTER'        => $_ARRAYLANG['TXT_SEND_NEWSLETTER'],
		    'TXT_SEND_MORE_TESTS'        => $_ARRAYLANG['TXT_TEST_ADDRESS'],
			'TXT_SEND_TEST_EMAIL'        => $_ARRAYLANG['TXT_SEND_TEST_EMAIL'],
			'TXT_SEND'                   => $_ARRAYLANG['TXT_SEND_NEWSLETTER'],
			'TXT_FIELD_REQUIRED'         => $_ARRAYLANG['TXT_NO_NEWSLETTER']
	//		'TXT_PLAIN'                  => $_ARRAYLANG['txtPlainText'],
		//	'TXT_HTML'               	   => $_ARRAYLANG['txtHtmlText'],
      	)); 
      	      	 
		$this->_objTpl->setVariable("NEWSLETTER_ARCHIV_LISTID", $archivlistid);
	
		$db->query("SELECT archivid,
		                   archivsubject 
		              FROM ".DBPREFIX."newsletter_archiv 
		             WHERE archivlistid='$archivlistid' 
		          ORDER BY archivid DESC");
		
		while($db->next_record()){
			$archivid= $db->f('archivid');	
			$archivsubject=	stripslashes($db->f('archivsubject'));
			$options.= "<option value='$archivid'>$archivsubject</option>\n";		
		}
		
		if (empty($options)){
			$options= "<option value='empty'>".$_ARRAYLANG['TXT_NO_NEWSLETTER']."</option>\n";	
		}
				
		$this->_objTpl->setVariable(array(
	      'NEWSLETTER_SEND_ARCHIVE'	   => $options,	 
		  'NEWSLETTER_ARCHIV_LISTID'     => $archivlistid,
		  'NEWSLETTER_ARCHIV_TESTMAIL'   => $testmail
		));
	}
	
			
	/**
	* Insert list
	* 
	* @global   array     $_CONFIG   
	* @global   object    $db 
	* @return   boolean                                                                          
	*/
	function insertList()
	{
		global $_CONFIG, $db;
	
		$ilistname = addslashes(strip_tags($_POST["listname"]));
		$ilistemailfrom = addslashes(strip_tags($_POST["listemailfrom"]));
		$ilistheader = addslashes($_POST["listheader"]);
		$ilistfooter = addslashes($_POST["listfooter"]);
		$ilistvalidmsg = addslashes($_POST["listvalidmsg"]);
		$ilistvalidmsgtitle = addslashes(strip_tags($_POST["listvalidmsgtitle"]));
		$ilistwelcomemsg = addslashes($_POST["listwelcomemsg"]);
		$ilistwelcomemsgtitle = addslashes(strip_tags($_POST["listwelcomemsgtitle"]));
		
		return $db->query("INSERT INTO ".DBPREFIX."newsletter_lists 
		                           SET listname='$ilistname',".
										"listemailfrom='$ilistemailfrom',".
										"listheader='$ilistheader',".
										"listfooter='$ilistfooter',".
										"listvalidmsg='$ilistvalidmsg',".
										"listvalidmsgtitle='$ilistvalidmsgtitle',".
										"listwelcomemsg='$ilistwelcomemsg',".
										"listwelcomemsgtitle='$ilistwelcomemsgtitle'");
	}
	
	/**
	* Gets the details of current newsletter list
	* 
	* @global   array     $_GET[listId]   
	* @global   object    $db 
	* @return   array     $listDetails                                                                          
	*/
	function getListDetails($id)
	{
	    global $db;
		
	    if ($_GET['listId'])
	       $db->query("SELECT * FROM ".DBPREFIX."newsletter_lists WHERE listid=".intval($_GET['listId']));
	    else 
	       $db->query("SELECT * FROM ".DBPREFIX."newsletter_lists WHERE listid=".$id);
	    while($db->next_record())
	    {
	    $listDetails = array("listid"=>$db->f('listid'),
	                         "listname"=>stripslashes($db->f('listname')),
	                         "listemailfrom"=>stripslashes($db->f('listemailfrom')),
	                         "listheader"=>stripslashes($db->f('listheader')),
	                         "listfooter"=>stripslashes($db->f('listfooter')),
	                         "listwelcomemsg"=>stripslashes($db->f('listwelcomemsg')),
	                         "listvalidmsg"=>stripslashes($db->f('listvalidmsg')),
	                         "listwelcomemsgtitle"=>stripslashes($db->f('listwelcomemsgtitle')),
	                         "listvalidmsgtitle"=>stripslashes($db->f('listvalidmsgtitle')));
	    }
	    return $listDetails;
	}
	
	
	/**
	* Updates the newsletter list
	*  
	* @global   array     $_GET[listId]  
	* @global   array     $_POST[*] 
	* @global   object    $db 
	* @return   boolean                                                                         
	*/
	function updateList()
	{
		global $db;
		$id = intval($_GET["listId"]);
		return $db->query("UPDATE ".DBPREFIX."newsletter_lists
	                       SET   listname='".addslashes(strip_tags($_POST["listname"]))."',
	                             listemailfrom='".addslashes(strip_tags($_POST["listemailfrom"]))."',
	                             listheader='".addslashes($_POST["listheader"])."',
	                             listfooter='".addslashes($_POST["listfooter"])."',
	                             listwelcomemsg='".addslashes($_POST["listwelcomemsg"])."',
	                             listvalidmsg='".addslashes($_POST["listvalidmsg"])."',
	                             listwelcomemsgtitle='".addslashes(strip_tags($_POST["listvalidmsgtitle"]))."',
	                             listvalidmsgtitle='".addslashes(strip_tags($_POST["listwelcomemsgtitle"]))."'
	                       WHERE listid=".$id);
	
	}
	
	
	/**
	* Deletes a list and all subscribers 
	*  
	* @global   array     $_GET[listId]   
	* @global   object    $db 
	* @return   boolean                                                                         
	*/
	function deleteList()
	{
	    global $db, $_CONFIG;
	    
		$returnValue = false;
		
	    $db->query("DELETE FROM ".DBPREFIX."newsletter_lists WHERE listid=".intval($_GET['listId']));
		if($db){
	        $db->query("DELETE FROM ".DBPREFIX."newsletter_emails WHERE emaillistid=".intval($_GET['listId']));
			if($db){		    	
		    	$db->query("SELECT archivid FROM ".DBPREFIX."newsletter_archiv WHERE archivlistid=".intval($_GET['listId']));
		    	while ($db->next_record()){		    														
					$file_array= $this->read_directory($this->attachmentPath,$db->f('archivid')); 
		    		if (!empty($file_array)){
			    		foreach ($file_array as $value){
				    		$fullpath= str_replace("//","/",$this->attachmentPath.$value);
							if(is_file($fullpath))		{
								if (!@unlink($fullpath)){
				    				return false;
				    			}		    			    	
							}
			    		}
		    		}
		    	}
		    	
	            $db->query("DELETE FROM ".DBPREFIX."newsletter_archiv WHERE archivlistid=".intval($_GET['listId']));
			    if($db) {
			        $returnValue = true;
		        }
		    }
		}
	    return $returnValue;
	}
	
	
	/**
	* Exports email addresses
	*  
	* @global   array     $_GET[listId]  
	* @global   array     $_POST[splitchar]  
	* @global   object    $db 
	* @return   string    $output                                                                         
	*/
	function exportAddresses()
	{
	    global $db, $_ARRAYLANG;
	    $output_start = "<form>\n<TEXTAREA NAME='exp' COLS='60' ROWS='20'>\n";
	    $output_end = "</TEXTAREA><br>";
	    $output_end .= "<INPUT onclick=javascript:this.form.exp.focus();this.form.exp.select(); type=button value='".$_ARRAYLANG['TXT_SELECT_ALL']."'>\n</form>";
		
	    $splitchar = $_POST['splitchar'];
	    $output = array();
	    $listId= intval($_REQUEST['listId']);
	    
	    if (!empty($_POST["exportlist"])){
	    	$toexport_array= explode(",",$_POST["exportlist"]);	    	    
	     	for ($j=0;$j<count($toexport_array);$j++){
	        	$sqlwhere1.=" emailid=".intval($toexport_array[$j]);
	        	if ($j<count($toexport_array)-1){
	        		$sqlwhere1.=" OR ";        	
	        	}
	        } 
	        $db->query("SELECT * FROM ".DBPREFIX."newsletter_emails WHERE $sqlwhere1");   
		} else {
			if ($_POST["exportlist"]!="-1") $db->query("SELECT * FROM ".DBPREFIX."newsletter_emails WHERE emaillistid='$listId'");			
		}   	

	    
	    while($db->next_record()){
	        $emailAddress = $db->f('emailadress');
	        $output[]= $emailAddress;
	    }
	    return $output_start.implode($splitchar."\n",$output).$output_end;
	}
	
	
	/**
	* Validates an email address
	*
	* @version  1.0       initial version   
	* @param    string    $emailaddress
	* @return   boolean                                                                          
	*/
	function checkAddress($emailaddress)
	{
	    $email=strtolower($emailaddress);
	    if( eregi( "^".
	            "[a-z0-9]+([_\\.-][a-z0-9]+)*". //user
	            "@".
	            "([a-z0-9]+([\.-][a-z0-9]+)*)+". //domain
	            "\\.[a-z]{2,4}". //sld, tld
	            "$", $email)
	     )
		{
	        return true;
	    } else {
	        return false;	
		}	
	}		
	
	/**
	* Imports e-mail addresses to the db
	*
	* @global   array     $_GET[listId]  
	* @global   array     $_POST[imports]   
	* @global   object    $db 
	* @return   boolean                                                                         
	*/
	function importAddresses()
	{
	    global $db, $_ARRAYLANG;
	    $addresses = ereg_replace('[[:space:],;]+','*',trim($_POST['imports']));
	    $tok = strtok($addresses,"*");
	    $status = "";
	    $listid = intval($_GET['listId']);
	    while($tok){
	    	$tok = get_magic_quotes_gpc() ? $tok : addslashes($tok);
			if($this->checkAddress($tok)){
				$db->query("SELECT emailid FROM ".DBPREFIX."newsletter_emails WHERE emailadress='".$tok."' AND emailvalidate=1 AND emaillistid='$listid'");
				if($db->num_rows()==0){
					$db->query("INSERT INTO ".DBPREFIX."newsletter_emails SET emailadress='".$tok."', emailvalidate='1', emaillistid='$listid',emaildate=CURDATE()");
					if($db)
					{
						$status .= "<font color=green>$tok ".$_ARRAYLANG['TXT_DATA_IMPORT_SUCCESSFUL']."</font><br>";;
					}else{
						$status .= "<font color=red>$tok ".$_ARRAYLANG['TXT_DATA_IMPORT_ERROR']."</font><br>";					
					}
				}else{
				    $status .= "<font color=blue>$tok ".$_ARRAYLANG['TXT_DATA_RECORD_ALREADY_EXISTS']."</font><br>";								
				}
			} else{
	                $status .= "<font color=red>$tok failed!</font><br>";		
			}
			$tok = strtok("*");
	    }
	    return $status;
	}
	
	
	/**
	* Gets the dropdown menu with the newsletter archive
	*
	* @global   object    $db 
	* @global   integer   $_REQUEST['listid']
	* @global   array     $_POST[*] 
	* @return   integer   $db->insert_id();                                                                        
	*/
	function archivInsert()
	{
		GLOBAL $db, $_CONFIG;
		
		$archivody = "";
		$archivlistid = intval($_REQUEST['archivlistid']);						
			
		$db->query("INSERT INTO ".DBPREFIX."newsletter_archiv SET " .
					"archivid='',".
					"archivlistid='".intval($archivlistid)."',".
					"archivfromemail='".htmlspecialchars($_POST[archivfromemail])."',".
					"archivfromname='".addslashes($_POST[archivfromname])."',".
					"archivsubject='".addslashes($_POST[archivsubject])."',".
					"archivbody='".addslashes($_POST[html])."',".
					"archivpriority='".intval($_POST[priority])."',".
					"archivhtml='".intval($_POST[htmlmode])."',".
					"archivdate=CURDATE()");
					
		@set_time_limit(0); // no time limit without safemode	
		for($i=1;$i<=$this->_NEWSLETTER_CONFIG["newsletterMaxAttachment"];$i++){	
			$tmp_fname= $_FILES["attach".$i]['name'];
			$tmp_ftype= $_FILES["attach".$i]['type'];
			$tmp_fsize= $_FILES["attach".$i]['size'];
			$tmp_ftemp= $_FILES["attach".$i]['tmp_name'];			
			$tmp_new= $db->insert_id()."_".strcheck($tmp_fname);
	
			$fullpath=str_replace("//","/",$this->attachmentPath.$tmp_new);					
			$file_array= $this->read_directory($this->attachmentPath,$db->f('archivid')); 
			
			if (!empty($tmp_fname) && !file_exists($fullpath) && !eregi(".php",$tmp_fname)){
				if (!@move_uploaded_file($tmp_ftemp, $fullpath)){				
					if (count($file_array)>=$this->_NEWSLETTER_CONFIG["newsletterMaxAttachment"]){
					   return $_ARRAYLANG["TXT_NEWSLETTER_MAX_ATTACHMENT"];
					}
					
					if (@ini_get('safe_mode')) {						
						return $_ARRAYLANG["TXT_SAFE_MODE_ERROR"];					  							
					}else {
						return $_ARRAYLANG["TXT_SUBMIT_ERROR"];			
					}
				}				 					
			}
		}												
		return $_ARRAYLANG["TXT_DATA_RECORD_STORED_SUCCESSFUL"];
	}
		

	
	
	/**
	* Updates the newsletter archive
	*
	* @global   object    $db 
	* @global   array     $_POST[*] 
	* @return   integer   $archiveId                                                                     
	*/
	function archivUpdate()
	{
	    GLOBAL $db, $_CONFIG, $_ARRAYLANG;
	    
		$archiveId = intval($_GET['archivid']);
			
		$db->query("UPDATE ".DBPREFIX."newsletter_archiv SET 
					archivlistid='".intval($_GET[archivlistid])."',
					archivfromemail='".stripslashes($_POST[archivfromemail])."',
					archivfromname='".stripslashes($_POST[archivfromname])."',
					archivsubject='".stripslashes($_POST[archivsubject])."',
					archivbody='".stripslashes($_REQUEST[html])."',
			        archivpriority='".intval($_POST[priority])."',
					archivhtml='".intval($_POST[htmlmode])."',
					archivdate=CURDATE() 
					WHERE archivid='".intval($archiveId)."'");	
	
		
		@set_time_limit(0); // no time limit without safemode	
		for($i=1;$i<=$this->_NEWSLETTER_CONFIG["newsletterMaxAttachment"];$i++){		
			$tmp_fname= $_FILES["attach".$i]['name'];
			$tmp_ftype= $_FILES["attach".$i]['type'];
			$tmp_fsize= $_FILES["attach".$i]['size'];
			$tmp_ftemp= $_FILES["attach".$i]['tmp_name'];			
			$tmp_new= $archiveId."_".stripslashes(strcheck($tmp_fname));
									
			$fullpath=str_replace("//","/",$this->attachmentPath.$tmp_new);
			
			$file_array= $this->read_directory($this->attachmentPath,$archiveId); 				
			if (!empty($tmp_fname) && !file_exists($fullpath) && !eregi(".php",$tmp_fname)){
				if (count($file_array)>=$this->_NEWSLETTER_CONFIG["newsletterMaxAttachment"]){				 
				   return $_ARRAYLANG["TXT_NEWSLETTER_MAX_ATTACHMENT"];
				}				
				elseif (!@move_uploaded_file($tmp_ftemp, $fullpath))				
				{
					if (@ini_get('safe_mode')) {						
						return $_ARRAYLANG["TXT_SAFE_MODE_ERROR"];					  							
					}
					else {
						return $_ARRAYLANG["TXT_SUBMIT_ERROR"];
					}					
				}				 					
			}
		}		
		return $_ARRAYLANG['TXT_DATA_RECORD_UPDATED_SUCCESSFUL'];
	}
	
	
	/**
	* Deletes the current newsletter
	* 
	* @global   object    $db 
	* @global   array     $_POST[*] 
	* @return   boolean   $db                                                                 
	*/
	function archivDelete()
	  {
		GLOBAL $db, $_CONFIG;
		
		if ($_GET['archivId']=="")
			return false;	
	
		$file_array= $this->read_directory($this->attachmentPath,$_GET['archivId']); 
		if (!empty($file_array)){
			foreach ($file_array as $value){
	    		$fullpath= str_replace("//","/",$this->attachmentPath.$value);
				if(is_file($fullpath)){
					if (!@unlink($fullpath)){
	    				return false;
	    			}		    			    	
				}
			}	
		}		
		$db->query("DELETE FROM ".DBPREFIX."newsletter_archiv WHERE archivid=".intval($_GET['archivId']));
		return $db;
	}
	
	
	/**
	* Deletes newsletter subscribers
	*
	* @global   object    $db 
	* @global   array     $_POST[*] 
	* @return   boolean   $returnValue                                                             
	*/
	function deleteUser()
	  {
		GLOBAL $db;
		$returnValue = false;
		
		if ($_REQUEST['op']=="delete" && !empty($_POST['formusers'])){
	    	$array_users=explode(",",$_POST['formusers']);
	    	foreach ($array_users as $value){
			    if ($_POST["checkEmailId".$value]==$value){
			    	$db->query("DELETE FROM ".DBPREFIX."newsletter_emails WHERE emailid=".intval($value));
			    	$returnValue = true;
			    }
	        }	
	    }
	    		
		return $returnValue;
	}
	
	
	/**
	* Send newsletter mail
	*  
	* @global   array     $_CONFIG   
	* @global   object    $db 
	* @param    integer	  $archivid
	* @param    string	  $testmail
	* @return   string    $status                                                             
	*/
	function sendmail($archivid, $testmail='')
	{
		GLOBAL $db, $_ARRAYLANG, $_CONFIG;
		
		require_once ASCMS_LIBRARY_PATH . '/phpmailer/class.phpmailer.php';		
		require_once(dirname(__FILE__) . '/class.html2text.php');
			
		$redirect_control = "<script>function redirect(){ window.location.replace('?cmd=newsletter&act=sendnewsletter&send=true&archivid=$archivid');} setTimeout('redirect();', 1000);</script>";
		@set_time_limit(0); // no time limit without safemode
		
		if (!isset($this->_NEWSLETTER_CONFIG['newsletterLimitSafemode']))
			$this->_NEWSLETTER_CONFIG['newsletterLimitSafemode'] = 50;
		
		if (!isset($this->_NEWSLETTER_CONFIG['newsletterSendLimit']))
			$this->_NEWSLETTER_CONFIG['newsletterSendLimit'] = 100;
		
		$safe_mode = ini_get('safe_mode'); //ON = 1
		if($safe_mode=="1")
			$limit = intval($this->_NEWSLETTER_CONFIG['newsletterLimitSafemode']);
		else
			$limit = intval($this->_NEWSLETTER_CONFIG['newsletterSendLimit']);
	
		$wordwrap = intval($this->_NEWSLETTER_CONFIG['newsletterWordWrap']);
		$status = "";
		$db->query("SELECT * FROM ".DBPREFIX."newsletter_archiv WHERE archivid=".intval($archivid)." LIMIT 1");
		$db->next_record();
		$from = $db->f('archivfromemail');
		$archivlistid = intval($db->f('archivlistid'));
		$fromname = stripslashes($db->f('archivfromname'));
		$subject = stripslashes($db->f('archivsubject'));
		$body = stripslashes($db->f('archivbody'));
		$priority = $db->f('archivpriority');		
		$emailhtml= intval($db->f('archivhtml'));
	
		$mail = new phpmailer();
		$mail->From = $from;
		$mail->FromName = $fromname;	
		$mail->WordWrap = $wordwrap;
		$mail->Subject = $subject;
		$mail->Priority = $priority;
																		
		$h2t =& new html2text($body);
		$bodyplain = $h2t->get_text();
			
		$fullpath= str_replace("//","/",$this->attachmentPath);
		$file_array= $this->read_directory($fullpath,$archivid); 	    
	    if (!empty($file_array)){
		    for ($j=0;$j<count($file_array);$j++){
		    	$mail->AddAttachment($this->attachmentPath.$file_array[$j], str_replace($archivid."_","",$file_array[$j]));		    
		    }			    			     
	    }
			    
		if($testmail!=''){
			$mail->Body = str_replace ("&lt;--UNSUBSCRIBE--&gt;","<a href=\"http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=testid&e=".$testmail."\">http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=testid&e=".$testmail."</a>", $body);		
			if ($emailhtml){
			   $mail->Body = str_replace ("&lt;--UNSUBSCRIBE--&gt;","<a href=\"http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=testid&e=".$testmail."\">http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=testid&e=".$testmail."</a>", $body);		
		       $mail->AltBody = str_replace ("<--UNSUBSCRIBE-->","http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=testid&e=".$testmail, $bodyplain);								
			} else {
			   $mail->Body = str_replace ("<--UNSUBSCRIBE-->","http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=testid&e=".$testmail, $body);			
			}
			$mail->AddAddress($testmail);	  		
			if(!$mail->Send())
			   $status = $_ARRAYLANG['TXT_SENDING_MESSAGE_ERROR']." ". $mail->ErrorInfo;
			else
			   $status = sprintf($_ARRAYLANG['TXT_TESTMAIL_SEND_SUCCESSFUL'],"<b>[ $testmail ]</b><br>");
			$mail->ClearAddresses();				 
		} else {
			$db2 = new astalavistaDB;
			$today = date(Ymd);
			$db->query("SELECT * FROM ".DBPREFIX."newsletter_emails WHERE (emaillistid=$archivlistid AND emailvalidate='1' AND emaillastsend<$today) LIMIT 0, $limit");
			if($db->num_rows()<1)
				return $_ARRAYLANG['TXT_NEWSLETTER_SEND_TO_ALL_SUBSCRIBERS_SUCCESSFUL'];
			$status .= $redirect_control;
						
			while($db->next_record()){
					$emailid = $db->f('emailid');
					$emailadress = $db->f('emailadress');														

					if ($emailhtml){
					   $mail->Body = str_replace ("&lt;--UNSUBSCRIBE--&gt;","<a href=\"http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=".$emailid."&e=".$emailadress."\">http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=".$emailid."&e=".$emailadress."</a>", $body);								
				       $mail->AltBody = str_replace ("<--UNSUBSCRIBE-->","http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=".$emailid."&e=".$emailadress, $bodyplain);								
					} else{
					    $mail->Body = str_replace ("<--UNSUBSCRIBE-->","http://".$_SERVER['HTTP_HOST']."/index.php?section=newsletter&id=".$emailid."&e=".$emailadress, $body);			
					}
											   
				    $mail->AddAddress($emailadress);
					if(!$mail->Send())
						$status .= $_ARRAYLANG['newsletterMailerError']." " .$mail->ErrorInfo; //n/a
					else{
						$db2->query("UPDATE ".DBPREFIX."newsletter_emails SET emaillastsend=CURDATE() WHERE emailid=$emailid");
						$status .= $_ARRAYLANG['TXT_SUCCESSFUL']." :: $emailadress [id: $emailid]<br>";												
					}
					// Clear all addresses and attachments for next loop
					$mail->ClearAddresses();								
			}			
		}
	  $mail->ClearAttachments();
	  return $status;
	}
  
  
	/**
	* Gets the parsed newsletter stats as a string
	*  
	* @global   array     $_CONFIG    
	* @global   object    $db 
	* @return   string    parsed newsletter statspage                                                          
	*/  
	function getStats()
	{
	    global $_CONFIG, $db, $_ARRAYLANG;	

	    if ($_POST["insert"]!=""){
		    if ($this->insertList())	 {
		    	$this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_ADDED_SUCCESSFUL'];//"Liste wurde erfolgreich eingefgt.";			                                                          
		    }else {
		    	$this->statusMessage= $_ARRAYLANG['TXT_DATABASE_ERROR'];
		    }
	    }
         
	    if ($_POST["update"]!=""){	    				    							
			if($this->updateList())	{		
			    $this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_UPDATED_SUCCESSFUL']; //"Die Liste wurde erfolgreich editiert.";
			}else {
				$this->statusMessage= $_ARRAYLANG['TXT_DATABASE_ERROR'];//"Die Liste konnte nicht editiert werden.";
			}
	    }   
	    
	    if ($_GET["op"]=="delete"){
			if($this->deleteList()){		
			    $this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
			}else {
				$this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];
			}
	    }						
	     
		$this->_objTpl->loadTemplateFile('newsletter_stats.html');
		$this->_objTpl->setVariable(array(
		    'TXT_LIST'                   => $_ARRAYLANG['TXT_LIST'],
		    'TXT_LIST_ID'                => $_ARRAYLANG['TXT_LIST_ID'],
		    'TXT_NEWSLETTER_NUMBER'      => $_ARRAYLANG['TXT_NEWSLETTER_NUMBER'],
		    'TXT_SUBSCRIBERS'            => $_ARRAYLANG['TXT_SUBSCRIBERS'],
		//    'TXT_VALID'                  => $_ARRAYLANG['txtValid'],
		//    'TXT_OPEN_ISSUE'             => $_ARRAYLANG['txtOpenIssue'],
		    'TXT_EXPORT'                 => $_ARRAYLANG['TXT_EXPORT'],
		    'TXT_ADD'                    => $_ARRAYLANG['TXT_ADD'],
		    'TXT_CREATE_HTML'            => $_ARRAYLANG['TXT_CREATE_HTML'],
		    'TXT_DELETE'                 => $_ARRAYLANG['TXT_DELETE'],
		    'TXT_TOTAL_SUBSCRIBERS'      => $_ARRAYLANG['TXT_TOTAL_SUBSCRIBERS'],
		    'TXT_CONFIRM_DELETE_DATA'    => $_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'],
		    'TXT_ACTION_IS_IRREVERSIBLE' => $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE'],
		    'TXT_EDIT'                   => $_ARRAYLANG['TXT_EDIT'],
		    'TXT_DELETE'                 => $_ARRAYLANG['TXT_DELETE'],
		    'TXT_ARCHIVE'                => $_ARRAYLANG['TXT_ARCHIVE'],
		    'TXT_ACTION'                 => $_ARRAYLANG['TXT_ACTION'],
		    'TXT_NEWSLETTER_USERS'       => $_ARRAYLANG['TXT_NEWSLETTER_USERS'],
		    'TXT_NEW'                    => $_ARRAYLANG['TXT_NEWSLETTER_NEW'], 
		 	'TXT_NEWSLETTER_SEND'        => $_ARRAYLANG['TXT_NEWSLETTER_SEND']
		));
		
		$db->query("SELECT listid,listname FROM ".DBPREFIX."newsletter_lists ORDER BY listid DESC");
		while($db->next_record()){
			$arraylist[$db->f('listid')]=$db->f('listname');
		}
		$db->query("SELECT emailid,emailvalidate,emaillistid FROM ".DBPREFIX."newsletter_emails");
		while($db->next_record()){
			$arraysubscriber[$db->f('emailid')][$db->f('emaillistid')]=$db->f('emailvalidate');
		}
		$cntList = count($arraylist);
		$cntSubscriber = count($arraysubscriber);
		$i=2;
		if (!empty($arraylist)){
			foreach ($arraylist as $key => $value) {
				$db->query("SELECT DISTINCT emailid FROM ".DBPREFIX."newsletter_emails WHERE emaillistid=$key");
				$totSubscriber = $db->num_rows();
				$db->query("SELECT DISTINCT emailid FROM ".DBPREFIX."newsletter_emails WHERE emaillistid=$key AND emailvalidate=1");
				$valSubscriber = $db->num_rows();
				$unvalSubscriber = $totSubscriber - $valSubscriber;
				
				$db->query("SELECT DISTINCT archivid FROM ".DBPREFIX."newsletter_archiv WHERE  archivlistid=$key");
				$valNewsletter = $db->num_rows();
				
				($i % 2)? $class = "row1" : $class = "row2";
				$i++;
			    $this->_objTpl->setVariable(array(
			    	'NEWSLETTER_STATS_CLASS'	=> $class,
			    	'NEWSLETTER_STATS_LIST'		=> $value,
			    	'NEWSLETTER_STATS_ID'		=> $key,
			    	'NEWSLETTER_STATS_ARCHIVE'	=> $valNewsletter,
			    	'NEWSLETTER_STATS_SUB'		=> $totSubscriber,
			    	'NEWSLETTER_STATS_VAL'		=> $valSubscriber,
			    	'NEWSLETTER_STATS_NOTVAL'	=> $unvalSubscriber,
			    	'TXT_HTML_CODE'				=> $_ARRAYLANG['TXT_HTML_CODE']
			    ));
				$this->_objTpl->parse("row");
			}
		} else {
			$this->_objTpl->hideBlock('row');
		}
		$this->_objTpl->setVariable("NEWSLETTER_STATS_TOT", $cntSubscriber);
	} 
	
	
	function deletePendentUser()
	{		
		GLOBAL $db, $_ARRAYLANG;				
		$listid= intval($_GET['listId']); 
		if (!empty($listid)){
			if ($db->query("DELETE FROM ".DBPREFIX."newsletter_emails WHERE emailvalidate=0 AND emaillistid=".$listid)) {
			   return $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];				
			}else{
			   return  $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];		              
			}
		}				
		return $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];		
	}
		
		
	/**
	* Gets the parsed show users page as a string
	* 
	* @global   array     $_CONFIG    
	* @global   object    $db 
	* @return   string    parsed newsletter statspage                                                          
	*/  
	function getUserPage()
	{
	    global $_CONFIG, $db, $_ARRAYLANG;	

    	if ($_REQUEST['op']=="delete"){
		    if(!$this->deleteUser()){	
				$this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];		              
			} else {
				$this->statusMessage= $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
			}
		} elseif ($_REQUEST['op']=="delpendent")	{
			$this->statusMessage= $this->deletePendentUser();			
		}		

		if(!empty($_POST['imports'])){
			$this->statusMessage= $this->importAddresses();
		}	
											
	    $this->_objTpl->loadTemplateFile('newsletter_showuser.html');
		$this->_objTpl->setVariable(array(
			'TXT_EDIT_SUBSCRIBER_LIST'   => $_ARRAYLANG['TXT_EDIT_SUBSCRIBER_LIST'],
			'TXT_ID_ADDRESS_CONTAINS'    => $_ARRAYLANG['TXT_ID_ADDRESS_CONTAINS'],
			'TXT_SEARCH'                 => $_ARRAYLANG['TXT_SEARCH'],
			'TXT_SUBSCRIBERS'            => $_ARRAYLANG['TXT_SUBSCRIBERS'],		
			'TXT_EMAIL'                  => $_ARRAYLANG['TXT_EMAIL'],
			'TXT_STATUS'                 => $_ARRAYLANG['TXT_STATUS'],
			'TXT_DATE'                   => $_ARRAYLANG['TXT_DATE'],
			'TXT_LAST_NEWSLETTER'        => $_ARRAYLANG['TXT_LAST_NEWSLETTER'],
			'TXT_EDIT'                   => $_ARRAYLANG['TXT_EDIT'],
			'TXT_OK'                     => $_ARRAYLANG['TXT_OK'],			
			'TXT_EXPORT_MARKED'          => $_ARRAYLANG['TXT_EXPORT_MARKED'],
			'TXT_DELETE_MARKED'          => $_ARRAYLANG['TXT_DELETE_MARKED'],
			'TXT_CONFIRM_DELETE_DATA'    => $_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'],
		    'TXT_ACTION_IS_IRREVERSIBLE' => $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE'], 	
		    'TXT_NO_USER_SELECTED'       => $_ARRAYLANG['TXT_NO_USER_SELECTED'], 
			'TXT_SUBSCRIBER_LIST'        => $_ARRAYLANG['TXT_SUBSCRIBER_LIST'],
			'TXT_DELETE_PENDENT'	      => $_ARRAYLANG['TXT_DELETE_PENDENT']
		));
		
		$listId	= intval($_REQUEST['listId']);
		$term	= htmlspecialchars($_REQUEST['term']);
		$pos    = intval($_GET['pos']);
		$i=2;
		$this->parseNavBar($listId);
		
		if ($term==""){
		    $query = "SELECT * 
		                FROM ".DBPREFIX."newsletter_emails 
		               WHERE emaillistid='$listId' 
		               ORDER BY emailid DESC";
		} elseif ($term=="notvalidated"){
		    $query = "SELECT * 
		                FROM ".DBPREFIX."newsletter_emails 
		               WHERE emailvalidate ='0' 
		    		   AND emaillistid='$listId' 
		               ORDER BY emailid DESC";	
		} else{
		    $query = "SELECT * 
		                FROM ".DBPREFIX."newsletter_emails 
		               WHERE emaillistid LIKE '%".$term."%' 
		                  OR emailadress LIKE '%".$term."%'
		                 AND emaillistid='$listId' 
		               ORDER BY emailid DESC";	
		}
		////// paging start /////////		
		$db->query($query);		
		$count = $db->num_rows();
		if(!is_numeric($pos)){
		  $pos = 0;
	    }
	    if ($count>intval($_CONFIG['corePagingLimit'])){	    
			$paging = getPaging($count, $pos, "&cmd=newsletter&act=showuser&term=".$term."&listId=".$listId, "<b>Eintrge</b>", true);
	    }
		////// paging end /////////
	
	    $pagingLimit = intval($_CONFIG['corePagingLimit']);
	    $db->query("$query LIMIT $pos, $pagingLimit");	    	    	   	    
		while($db->next_record()){
			$arrayid[]=$db->f('emailid');
			($i % 2)? $class = "row2" : $class = "row1";
			($db->f('emailvalidate'))? $mailstatus=$_ARRAYLANG['TXT_ACTIVE'] : $mailstatus=$_ARRAYLANG['TXT_OPEN_ISSUE']; 
			$i++;
		    $this->_objTpl->setVariable(array(
		    	'NEWSLETTER_SHOWUSER_CLASS'	=> $class,
		    	'NEWSLETTER_SHOWUSER_ID'	=> $db->f('emailid'),
		    	'NEWSLETTER_SHOWUSER_ADDRESS'	=> $db->f('emailadress'),
		    	'NEWSLETTER_SHOWUSER_STATUS'	=> $mailstatus,
		    	'NEWSLETTER_SHOWUSER_DATE'		=> $db->f('emaildate'),
		    	'NEWSLETTER_SHOWUSER_LASTSEND'	=> $db->f('emaillastsend'),
		    	'TXT_EDIT'                      => $_ARRAYLANG['TXT_EDIT']
		    ));
			$this->_objTpl->parse("row");
		}
		(empty($arrayid))? $arrayoutput="" : $arrayoutput=implode(",",$arrayid);
		$this->_objTpl->setVariable(array(
			'NEWSLETTER_USERIDS'			=> $arrayoutput,
			'NEWSLETTER_SHOWUSER_URI'		=> "?cmd=newsletter&act=showuser&pos=".$pos."&listId=".$listId,
			'NEWSLETTER_SHOWUSER_PAGING'	=> $paging,
			'NEWSLETTER_SHOWUSER_LISTID'	=> $listId,
			'NEWSLETTER_SHOWUSER_POS'		=> $pos
		));
	}  
	 
	
	
	
	/**
	* Gets the edit user page
	*
	* @global   array     $_CONFIG     
	* @global   object    $db 
	* @global   array     $_POST
	* @return   string    parsed newsletter statspage                                                          
	*/  
	function getEditUserPage()
	{
	    global $_CONFIG, $db, $_ARRAYLANG;	

	    $this->_objTpl->loadTemplateFile('newsletter_edituser.html');
		$this->_objTpl->setVariable(array(
		    'TXT_USER_ID'         => $_ARRAYLANG['TXT_USER_ID'],
		    'TXT_EMAIL_ADDRESS'   => $_ARRAYLANG['TXT_EMAIL_ADDRESS'],
		    'TXT_STATUS'          => $_ARRAYLANG['TXT_STATUS'],
		    'TXT_ACTIVE'          => $_ARRAYLANG['TXT_ACTIVE'],
		    'TXT_OPEN_ISSUE'      => $_ARRAYLANG['TXT_OPEN_ISSUE'],
		//    TXT_DATE'            => $_ARRAYLANG['TXT_DATE'],
		//    TXT_LAST_NEWSLETTER' => $_ARRAYLANG['txtLastNewsletter'],
		    'TXT_RESET'           => $_ARRAYLANG['TXT_RESET'],
		    'TXT_SUBMIT'          => $_ARRAYLANG['TXT_SUBMIT'],
		    'TXT_EDITUSER'        => $_ARRAYLANG['TXT_EDIT']
		));
		$emailId = intval($_GET['emailId']);
		$listId	= intval($_GET['listId']);
		$this->parseNavBar($listId);
		
		// Modify
	    if(isset($_POST['edituser_modify'])) {
	    	$emailAddress = get_magic_quotes_gpc() ? strip_tags($_POST['emailaddress']) : addslashes(strip_tags($_POST['emailaddress']));
	    	
	    	
		    $db->query("UPDATE ".DBPREFIX."newsletter_emails
	                       SET emailadress='".$emailAddress."', emaildate=emaildate , emaillastsend=emaillastsend, emailvalidate=".intval($_POST[emailvalidate])." WHERE emailid=$emailId");
						 
	        header("Location: ?cmd=newsletter&act=showuser&listId=".$listId);
	        exit;
	    }
		$query = "SELECT * FROM ".DBPREFIX."newsletter_emails WHERE emailid='$emailId' AND emaillistid ='$listId' LIMIT 1";
	    $db->query($query);
		while($db->next_record()){
			$this->_objTpl->setVariable(array(
				'NEWSLETTER_EDITUSER_EMAILADDRESS'	=> $db->f('emailadress'),
				'NEWSLETTER_EDITUSER_EMAILVALIDATE'	=> $db->f('emailvalidate')
			));
		}
		$this->_objTpl->setVariable(array(
			'NEWSLETTER_EDITUSER_EMAILID'	=> $emailId,
			'NEWSLETTER_EDITUSER_URI'		=> "?cmd=newsletter&act=edituser&emailId=$emailId&listId=$listId"
		));
	}
	
	
	/**
	* Gets the newsletter news page
	*
	* @global   array     $_CONFIG    
	* @global   object    $db 
	* @return   string    parsed news page                                                         
	*/ 
	function getNewsPage() 
	{
	    global $db, $_ARRAYLANG;	

	    $this->_objTpl->loadTemplateFile('newsletter_news.html');
	    $this->_objTpl->setVariable(array(
	        'TXT_SHOW_NEWS'                   => $_ARRAYLANG['TXT_SHOW_NEWS'],
	        'TXT_LINK_TO_REPORT_INFO_SOURCES' => $_ARRAYLANG['TXT_LINK_TO_REPORT_INFO_SOURCES'],
	        'TXT_SELECT_ALL'                  => $_ARRAYLANG['TXT_SELECT_ALL']
	    ));
	    $this->_objTpl->setVariable("NEWSLETTER_CONTENT_TITLE", $this->_NEWSLETTER_CONFIG['newsletterContentTitle']);
	    
	    if ($_POST['newslimit']=="" OR !is_numeric($_POST['newslimit']) ) {
		    $newslimit = 20;
		} else {
		    $newslimit = intval($_POST['newslimit']);
		} 
	    $db->query("SELECT * FROM ".DBPREFIX."module_news ORDER BY id DESC LIMIT 0,$newslimit");
	    while($db->next_record()){
		    $this->_objTpl->setVariable(array(
		    	'NEWSLETTER_NEWS_DATE'	=> date("d.m.Y",$db->f('date')),
		    	'NEWSLETTER_NEWS_TITLE'	=> $db->f('title')."\n"
		    ));
		    $this->_objTpl->parse("row");
		
		    $this->_objTpl->setVariable(array(
		    	'NEWSLETTER_NEWS_DETAIL_DATE'	=> date("d.m.Y",$db->f('date')),
		    	'NEWSLETTER_NEWS_DETAIL_TITLE'	=> $db->f('title')
		    ));
		    $newstext = substr(ltrim(strip_tags($db->f('text'))), 0, 800);
		    $newstext .= "[....]";
		    $newslink = $this->newsletterUri."/index.php?section=news&cmd=details&newsid=".$db->f('id');
		    $this->_objTpl->setVariable(array(
		    	'NEWSLETTER_NEWS_DETAIL_TEXT' => $newstext,
		    	'NEWSLETTER_NEWS_DETAIL_LINK' => $newslink
		    ));
		    $this->_objTpl->parse("detailrow");
	    }
	}
	
	
	function parseNavBar($archivlistid) 
	{		
		global $_ARRAYLANG;
		$this->_objTpl->addBlockfile('NEWSLETTER_NAV', 'newsletter_navbar', 'newsletter_navbar.html');
		$arraylist=$this->getListDetails($archivlistid);	
			
		$this->_objTpl->setVariable(array(
			'NEWSLETTER_ID' 			   => $archivlistid,
			'TXT_ARCHIVE'   			   => $arraylist['listname'],
			'TXT_HTML_CODE'              => $_ARRAYLANG['TXT_HTML_CODE'],	
		    'TXT_NEWSLETTER_USERS'       => $_ARRAYLANG['TXT_NEWSLETTER_USERS'],
		    'TXT_NEW'                    => $_ARRAYLANG['TXT_NEWSLETTER_NEW'], 
		 	'TXT_NEWSLETTER_SEND'        => $_ARRAYLANG['TXT_NEWSLETTER_SEND'],
		    'TXT_IMPORT'                 => $_ARRAYLANG['TXT_IMPORT'],
			'TXT_EXPORT'                 => $_ARRAYLANG['TXT_EXPORT'],	
			'TXT_ARCHIVE_ALT'            => $_ARRAYLANG['TXT_ARCHIVE']
      	));
    }

    
    
	function size_format($filesize)
	{
	    $type = Array ('bytes', 'Kbytes', 'Mbytes', 'Gbytes');	    
	    for ($i=0; $filesize>1024; $i++) {
	        $filesize/= 1024;
	    }
	    return (round ($filesize, 2)." $type[$i]"); 
	}     
}
?>