<?PHP
/**
* Modul Newsletter
*
* Different functions to manage the newsletter
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>   
* @module newsletter
* @modulegroup modules 
* @access public
* @version 1.0.0   
*/

class newsletter
{		
	var $pageContent;
    var $_objTpl; 
    var $newsletterUri;
    
    
  
    /**
    * Constructor
    *
    * @param  string  
    * @access public
    */
    function newsletter($pageContent)
    {
    	global $_ARRAYLANG, $db; 
		$this->pageContent = $pageContent;  	
		
		$this->_objTpl = &new HTML_Template_Sigma();
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
		
		// example: http://www.contrexx.com/demo ( without slash )		
		$this->newsletterUri = strtolower(ASCMS_PROTOCOL)."://".$_SERVER['HTTP_HOST'].ASCMS_PATH_OFFSET;	
    }
    
	/**
	* Gets the Page
	*
	* @global   array    $_ARRAYLANG[newsletter*]   
	* @global   array    $_GET[]    
	* @global   array    $_REQUEST[]   
	* @return   string   $status                                                                                
	*/
	function getPage()
	{
	    global $_ARRAYLANG;
	    
	    $listId	= intval($_REQUEST['listId']);
		$e = get_magic_quotes_gpc() ? strtolower(strip_tags($_REQUEST['e'])) : addslashes(strtolower(strip_tags($_REQUEST['e'])));
		$id	= intval($_REQUEST['id']);
		$html = intval($_REQUEST['html']);	
		$this->_objTpl->setTemplate($this->pageContent); 
		$showNewsletterForm = true;	
		
		// subscribe
		if($listId!="") {
	        if($this->checkAddress($e)){
			    $status = $this->subscribe($listId,$e,$html);
			    $showNewsletterForm = false;			    
			}else{
			    $status = $_ARRAYLANG['TXT_INVALID_EMAIL_ADDRESS'];
			}	
		}
		// confirm or unsubscribe
		else if($id!="") {
	        if($this->checkAddress($e)){
	        	// confirm
			    if($this->checkStatus($id,$e)) {
				    $status = $this->validate($id, $e);				    
				}else{
				    $status = $this->unsubscribe($id, $e);
				}
			}else{
			    $status = $_ARRAYLANG['TXT_NEWSLETTER_SUBSCRIBER_ALREADY_INSERTED'];
			}
		} else {
			// show the default register form
	        $status = "";
		}
		
		if($this->_objTpl->blockExists("newsletterForm") && $showNewsletterForm){
			$this->_objTpl->touchBlock("newsletterForm");
		} 
			
		$this->_objTpl->setVariable("NEWSLETTER_STATUS", $status);	 	 	 
		return $this->_objTpl->get();
	}
	
	
	/**
	* Register subscribers and sends welcome message
	*
	* @global   array     $_ARRAYLANG[newlsetter*]    
	* @global   object    $db 
	* @param    integer   $listId 
	* @param    string    $subscriber 
	* @return   string    insertMail message                                                                               
	*/
	function subscribe($listId,$subscriber,$html)
	{
	    global $db, $_ARRAYLANG;
	
	    $db->query("SELECT * FROM ".DBPREFIX."newsletter_emails WHERE emailadress='$subscriber' AND emaillistid='$listId'");
	    if($db->num_rows()>=1){
		    return $_ARRAYLANG['TXT_NEWSLETTER_SUBSCRIBER_ALREADY_INSERTED'];
	    }else{
		    $db->query("INSERT INTO ".DBPREFIX."newsletter_emails SET emailadress='$subscriber',".
																	"emailvalidate='0',".
																	"emaillistid='$listId',".
																	"emaildate=CURDATE()");																
		    $emailId = $db->insert_id();
			$this->sendMessage($emailId, $subscriber, $messageType = "subscribe");		
		    return $_ARRAYLANG['TXT_NEWSLETTER_SUBSCRIBE_OK'];
		    
		}
	}
	
	
	/**
	* Sends the subscriber or welcome messagee
	*
	* @global   array     $_CONFIG  
	* @global   array     $_ARRAYLANG[newsletter*] 
	* @global   object    $db 
	* @param    integer   $emailId 
	* @param    string    $subscriber 
	* @param    string    $messageType (welcome or subscribe)                                                                               
	*/
	function sendMessage($emailId, $subscriber, $messageType = "welcome")
	{
		global $db, $_CONFIG, $_ARRAYLANG;
		
		require_once ASCMS_LIBRARY_PATH . '/phpmailer/class.phpmailer.php';
		require_once(dirname(__FILE__) . '/class.html2text.php');
			
		$db->query("SELECT emaillistid FROM ".DBPREFIX."newsletter_emails WHERE emailid ='$emailId' AND emailadress='$subscriber' LIMIT 1");
		$db->next_record();
		$emailListId = $db->f('emaillistid');
		
		$db->query("SELECT * FROM ".DBPREFIX."newsletter_lists WHERE listid='$emailListId'");
		$db->next_record();
		$from = $db->f('listemailfrom');
		$fromName = $db->f('listname');				
		
		
		if ($messageType == "subscribe"){
		    $message = $db->f('listvalidmsg');
		    $message = str_replace ("<--CONFIRMATION-->",$this->newsletterUri."/index.php?section=newsletter&id=".$emailId."&e=".$subscriber, $message);	    
		    $subject = $db->f('listvalidmsgtitle');
		} else {
		    // Welcome message
		    $message = $db->f('listwelcomemsg');
		    $message = str_replace ("<--UNSUBSCRIBE-->",$this->newsletterUri."/index.php?section=newsletter&id=".$emailId."&e=".$subscriber, $message);
		    $subject = $db->f('listwelcomemsgtitle');	
		}
		
		$mail = new phpmailer();			
		$mail->From = $from;
		$mail->FromName = $fromName;
		$mail->AddReplyTo($from, $fromName);
		$mail->AddAddress($subscriber);
		$mail->Subject = $subject;		
		$mail->Body = $message;
		if(!$mail->Send()){
			print $status = $_ARRAYLANG['TXT_SENDING_MESSAGE_ERROR']." ". $mail->ErrorInfo;
		}
		$mail->ClearAddresses();
	}
	
	
	/**
	* Unsubscribe the user
	*
	* @global   array     ARRAYLANG[newsletter*]    
	* @global   object    $db 
	* @param    integer   $emailId 
	* @param    string    $subscriber 
	* @return   string    unsubscribe message                                                                               
	*/
	function unsubscribe($emailId,$subscriber)
	{
		global $db, $_ARRAYLANG;
		$db->query("DELETE FROM ".DBPREFIX."newsletter_emails WHERE emailid='$emailId' AND emailadress='$subscriber'");
	    if($db){
	        return $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
		}else{
			return $_ARRAYLANG['TXT_DATA_RECORD_DELETE_ERROR'];		
		}
	}
	
	/**
	* Checks if the subscriber exists or not exists
	*   
	* @global   object    $db 
	* @param    integer   $emailId 
	* @param    string    $subscriber 
	* @return   boolean   true=exists, false=not_exists                                                                           
	*/
	function checkStatus($emailId,$subscriber)
	{
	    global $db;
		$status = false;
	    $db->query("SELECT * FROM ".DBPREFIX."newsletter_emails WHERE emailid='$emailId' AND emailadress='$subscriber'");
		while($db->next_record()){
			if($db->f('emailvalidate')=='0'){
			    $status = true;
			}
		}
		return $status;
	}
	
	/**
	* Checks if the subscriber exists or not exists
	*  
	* @global   array     $_ARRAYLANG[newsletter*]   
	* @global   object    $db 
	* @param    integer   $emailId 
	* @param    string    $subscriber 
	* @return   string    $status                                                                          
	*/
	function validate($emailId, $subscriber)
	{
		global $db, $_ARRAYLANG;
		$db->query("UPDATE ".DBPREFIX."newsletter_emails SET emailvalidate='1' WHERE emailid='$emailId' AND emailadress='$subscriber'");
	    if($db){
			$this->sendMessage($emailId, $subscriber, $messageType = "welcome");
			return $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_SUCCESSFUL'];
		} else{
			return $_ARRAYLANG['TXT_NEWSLETTER_CONFIRMATION_ERROR'];	
		}
	}
	
	/**
	* Validates an email address
	* 
	* @param    string    $emailaddress
	* @return   boolean                                                                          
	*/
	function checkAddress($emailaddress)
	{
	    $email=strtolower($emailaddress);
	    if( eregi( "^".
	            "[a-z0-9]+([_\\.-][a-z0-9]+)*". //user
	            "@".
	            "([a-z0-9]+([\.-][a-z0-9]+)*)+". //domain
	            "\\.[a-z]{2,4}". //sld, tld
	            "$", $email)
	     ) {
	        return true;
	    } else{
	        return false;	
		}	
	}	
}				
?>